SystemOrganization addCategory: 'OrbeonBPMWeb'!

SEWAFWebLogin subclass: #WAOrbeonProcessLogin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWeb'!

!WAOrbeonProcessLogin methodsFor: 'other' stamp: 'BrunoBB 06/29/2015 16:54'!
style

	^'
h1 {margin-left: 20%;}
body {
	margin-bottom: 25px !!important;
	background-color: darkgrey;
}
#flags {
	float: right;
}
#flags img {
	margin-right: 5px;
}
#login {
	border-radius: 25px;
	padding-top: 20px;
	padding-bottom: 20px;
    width: 50%; 
    margin: 0 auto;
	background-color: lightblue;
}
#login form{
    width:50%;
	background-color: lightblue;
	margin-left: 20%;
}
#login form p{
	color: darkred;
}
#user {
	margin-bottom: 5px;
	display: inline-block;
	width: 80%;
}
#user input {
	border-radius: 15px;
	float: right;
}
#user label {
	float: left;
}
#password {
	display: inline-block;
	width: 80%;
}
#password label {
	float: left;
}
#password input {
	border-radius: 15px;
	float: right;
}
#login-button {
	float: right;
}
#login-button input {
	border-radius: 8px;
	margin-right: -20px;
}'! !

!WAOrbeonProcessLogin methodsFor: 'other' stamp: 'BrunoBB 02/03/2016 09:43'!
tryLogin
	| logedUser |

	((self getGemStoneServerConfiguration loginModeFor: 'orbeon-processes-web') validateUser: name password: password)
	ifFalse: [^loginAttempts := loginAttempts + 1].

	logedUser := BpmUser cache at: name.

	self session user: logedUser.

	"self show: (WAOrbeonFormUser on: logedUser)."

	self show: (WAProcessUserPortal on: logedUser).! !

SewafLateralListComposite subclass: #WAOrbeonNewProcessBrowser
	instanceVariableNames: 'andApplication orApplication andApplications orApplications'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWeb'!

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/18/2015 14:03'!
addAndApplication

	(andApplication notNil and: [andApplication notEmpty])
	ifTrue: [andApplications add: andApplication].

	andApplication := nil! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/18/2015 14:03'!
addOrApplication

	(orApplication notNil and: [orApplication notEmpty])
	ifTrue: [orApplications add: orApplication].

	orApplication := nil! !

!WAOrbeonNewProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 12/17/2015 13:39'!
andApplication
	^andApplication! !

!WAOrbeonNewProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 12/17/2015 13:39'!
andApplication: newValue
	andApplication := newValue! !

!WAOrbeonNewProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 12/17/2015 13:39'!
andApplications
	^andApplications! !

!WAOrbeonNewProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 12/17/2015 13:39'!
andApplications: newValue
	andApplications := newValue! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 02/25/2016 12:32'!
createInstanceProcessFor: anBpmProcessDefinition
	"Create a new OrbeonFormProcess based on the definition OrbeonFormProcessDefinition <selectedDefinition> for the user <anOrbeonFormUser>.
	1- Create an OrbeonProcessAssignment.
	2- Create an OrbeonFormProcess.
	3- Associate the Assignment with the Process.
	4- The user <anOrbeonFormUser> take the assignment <anOrbeonProcessAssignment>"
	| processInstance |

	processInstance := anBpmProcessDefinition createProcessInstance: self session user.

	processInstance 
		andContextApplications: ((andApplications collect: [:each | self getApplicationManagerClass getAnyApplicationNamed: each]) select: [:each | each notNil]);
		orContextApplications: ((orApplications collect: [:each | self getApplicationManagerClass getAnyApplicationNamed: each]) select: [:each | each notNil]);
		triggerStartEvent.

	^processInstance! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/17/2015 13:39'!
downloadProcessMap

	^self downloadProcessMapOf: self selectedLateralItem! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/17/2015 13:39'!
downloadProcessMapOf: aBpmProcessDefinition
	| stream |

	stream := PrintStream on: String new.

	stream nextPutAll: '<?xml version="1.0" encoding="utf-8"?>', String lf,aBpmProcessDefinition xmlString.

	self requestContext respond: [:response | 
        response document: ((stream contents asByteArray seasideMimeDocument) 
                                        mimeType: 'application/csv'; 
                                        fileName: (aBpmProcessDefinition processName, '.xpdl'); 
                                        yourself)].

	aBpmProcessDefinition subProcess do: [:each | self downloadProcessMapOf: each]! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/17/2015 13:39'!
getAllFormProcessDefinition

	^self session user getCreationProcesses! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/17/2015 13:39'!
getCurrentCollection

	^lateralCollection! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/17/2015 13:39'!
getIconNameFormItem

	^#processadd32Png! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/17/2015 13:39'!
getTextForItem: aLateralListItem

	^aLateralListItem processName! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 14:45'!
getUserApplications

	^self session user getApplications 
		remove: selectedLateralItem application ifAbsent: [];
		yourself! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 15:25'!
initialize

	super initialize.

	andApplications := OrderedCollection new.
	orApplications := OrderedCollection new.

	batchedList := SewafLateralBatchedList parentComponent: self.
	batchedList batchSize: 5;
		navigationCssClass: 'batch-div-lateral-top'.! !

!WAOrbeonNewProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 12/17/2015 13:39'!
orApplication
	^orApplication! !

!WAOrbeonNewProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 12/17/2015 13:39'!
orApplication: newValue
	orApplication := newValue! !

!WAOrbeonNewProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 12/17/2015 13:39'!
orApplications
	^orApplications! !

!WAOrbeonNewProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 12/17/2015 13:39'!
orApplications: newValue
	orApplications := newValue! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/18/2015 12:42'!
removeAllAnd

	andApplication := nil.
	andApplications := OrderedCollection new.! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/18/2015 12:44'!
removeAllOr

	orApplication := nil.
	orApplications := OrderedCollection new.! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/19/2015 17:03'!
renderAndDetailsOn: html

	html output: 'The application of this process is [', selectedLateralItem applicationName, ']. By adding new applications in the AND Application Context the user has to belong to ALL added application in order to have access to this process.'! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/19/2015 16:17'!
renderApplicationContextOn: html forApplication: anOrderedCollection withSeparator: aString
	| aStream |

	aStream := PrintStream on: String new.

	anOrderedCollection isEmpty ifTrue: [^''].

	anOrderedCollection do: [:each | aStream nextPutAll:  (each, aString)].

	^html legend: (aStream contents allButLast: 3)! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 03/06/2016 16:54'!
renderContentOn: html
	| widthClass |

"	html div id: 'top-search-area'; with: [self renderSearchAreaOn: html.]."

	showLateralList ifTrue: [
		html div id: 'lateral-definition-list'; class: 'lateral-left-list'; 
			with: [self renderLateralListOn: html]].

	widthClass := showLateralList ifFalse: ['lateral-right-component-width100'] ifTrue: ['lateral-right-component-width80'].

	html div id: 'process-definition'; class: ('lateral-right-component ', widthClass);
		with: [html horizontalRule.
				self renderCompleteItemOn: html].! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 15:12'!
renderItemComponentOn: html

	selectedLateralItem ifNil: [andApplications := OrderedCollection new. ^orApplications := OrderedCollection new].

	self renderNewProcessCommandIconOn: html.

	html div id: 'new-process-options-form'; with: [
		self renderNewProcessAndOptionsOn: html.
		self renderNewProcessOrOptionsOn: html.
	].

	html div id: 'artifact-definitions'; with: [
		selectedLateralItem getOrderedTasks do: [:taskDefinition | 
			html div class: 'artifact-definition'; with: [html output: taskDefinition printNameAndDefinitionType]]
	].! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/17/2015 13:39'!
renderItemDescriptionAditionalDataOn: html! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/17/2015 13:39'!
renderItemDescriptionSecondaryDataOn: html

	selectedLateralItem ifNil: [^self].

	html span with: [html strong: ('Version:' translateFor: self session user)].
	html output: selectedLateralItem version.

	html span with: [html strong: ('Application:' translateFor: self session user)].
	html output: selectedLateralItem applicationName.! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/17/2015 13:39'!
renderItemDescriptionTitleOn: html

	selectedLateralItem ifNil: [^self].
	
	html output:  ('Create new Instance of [' translateFor: self session user), selectedLateralItem processName, ']'.

	html anchor 
		callback: [self downloadProcessMap]; 
		with: [html image url: (SEWAFIconLibrary / #documentflowchart24Png); 
					title: ('Process Map' translateFor: self session user);
					altText: ('Process Map' translateFor: self session user)].! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/17/2015 13:39'!
renderLateralItemDetailsOn: html for: aLateralItem! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 12:33'!
renderNewProcessAndOptionsOn: html

	html div class: 'centered-forms'; with: [
		html form with: [
			html fieldSet with: [
				html label with: 'Application'.
				html select 
					list: (#(' '), ((self getUserApplications collect: [:each | each applicationName]) asSortedCollection difference: andApplications)); 
					title: 'Available Form Applications';
					callback: [:value | andApplication := value].
				html submitButton callback: [self addAndApplication] ; with: ('Add Application' translateFor: self session user).
				html submitButton callback: [self removeAllAnd] ; with: ('Remove All' translateFor: self session user).
			].
			self renderApplicationContextOn: html forApplication: andApplications withSeparator: ' & '.
			self renderAndDetailsOn: html.
		].
	].! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/18/2015 13:32'!
renderNewProcessCommandIconOn: html

	html div class: 'centered-forms'; with: [
		self selectedLateralItem ifNotNil: [self renderNewProcessIconOn: html for: self selectedLateralItem].
	].! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/18/2015 13:17'!
renderNewProcessIconOn: html for: aBpmProcessDefinition

	html anchor callback: [self createInstanceProcessFor: aBpmProcessDefinition];
		with: [html image url: (SEWAFIconLibrary / #processadd32Png); 
					altText: ('Create New Process' translateFor: self session user);
					title: ('Create New Process' translateFor: self session user)].! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 12:33'!
renderNewProcessOrOptionsOn: html

	html div class: 'centered-forms'; with: [
		html form with: [
			html fieldSet with: [
				html label with: 'Application'.
				html select 
					list: (#(' '), ((self getUserApplications collect: [:each | each applicationName]) asSortedCollection difference: orApplications)); 
					title: 'Available Form Applications';
					callback: [:value | orApplication := value].
				html submitButton callback: [self addOrApplication] ; with: ('Add Application' translateFor: self session user).
				html submitButton callback: [self removeAllOr] ; with: ('Remove All' translateFor: self session user).
			].
			self renderApplicationContextOn: html forApplication: orApplications withSeparator: ' | '.
			self renderOrDetailsOn: html.
		].
	].! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/19/2015 17:03'!
renderOrDetailsOn: html

	html output: 'The application of this process is [', selectedLateralItem applicationName, ']. By adding new applications in the OR Application Context the user has to belong to ANY added application in order to have access to this process.'! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/18/2015 13:17'!
renderProcessDefinitionOn: html for: eachProcess

	html div class: 'unique-wide-list-item-summary'; with: [
		html div class: 'unique-wide-list-item-data'; with: [
			html strong with: [html span: ('Process Id:' translateFor: self session user)].
			html output: eachProcess processId.].
		html div class: 'unique-wide-list-item-data'; with: [
			html strong with: [html span: ('Process Name:' translateFor: self session user)].
			html output: eachProcess processName.].
		html div class: 'unique-wide-list-item-data'; with: [
			html strong with: [html span: ('Version:' translateFor: self session user)].
			html output: eachProcess version.].
		html div class: 'unique-wide-list-item-data'; with: [
			html strong with: [html span: ('Application:' translateFor: self session user)].
			html output: eachProcess applicationName.].
	].! !

SewafLateralListComposite subclass: #WAOrbeonProcessBrowser
	instanceVariableNames: 'seasideK mode categories transitionsHeight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWeb'!

WAOrbeonProcessBrowser subclass: #WAEmbeddedProcessBrowser
	instanceVariableNames: 'orbeonFrame orbeonIsOnPage isEditMode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWeb'!

!WAEmbeddedProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/02/2015 15:22'!
hasIFrame

	^orbeonFrame notNil! !

!WAEmbeddedProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/02/2015 15:22'!
initialize

	super initialize.

	orbeonIsOnPage := false.
	isEditMode := false.! !

!WAEmbeddedProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 06/02/2015 15:22'!
isEditMode
	^isEditMode! !

!WAEmbeddedProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 06/02/2015 15:22'!
isEditMode: newValue
	isEditMode := newValue! !

!WAEmbeddedProcessBrowser methodsFor: 'orbeon links' stamp: 'BrunoBB 12/11/2015 08:48'!
linkToOrbeonFormFor: aBpmArtifactInstance
	"The receiver gives the control to Orbeon Java application."
	| uuid |

	uuid  := OrbeonTempServiceRegistry default 
					createEntryToOrbeonFor: aBpmArtifactInstance 
					for: self session user.

	orbeonFrame := self getUrlFor: aBpmArtifactInstance with: uuid.! !

!WAEmbeddedProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 06/02/2015 15:22'!
orbeonFrame
	^orbeonFrame! !

!WAEmbeddedProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 06/02/2015 15:22'!
orbeonFrame: newValue
	orbeonFrame := newValue! !

!WAEmbeddedProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 06/02/2015 15:22'!
orbeonIsOnPage
	^orbeonIsOnPage! !

!WAEmbeddedProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 06/02/2015 15:22'!
orbeonIsOnPage: newValue
	orbeonIsOnPage := newValue! !

!WAEmbeddedProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 07/01/2015 12:32'!
renderContentOn: html
	| widthClass |

	seasideK := self requestContext request at: '_k' ifAbsent: ['error'].

	self hasIFrame ifFalse: [^super renderContentOn: html].

	html div id: 'top-search-area'; with: [self renderSearchAreaOn: html.].

	showLateralList ifTrue: [
		html div id: 'lateral-assignment-list'; with: [self renderLateralListOn: html]].

	widthClass := showLateralList ifFalse: ['process-assignment-width100'] ifTrue: ['process-assignment-width80'].
	
	html div id: 'process-assignment'; class: widthClass;
		with: [self renderEmbeddedProcessAssignmentOn: html.
				self renderContentWithFrameOn: html].! !

!WAEmbeddedProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/27/2015 14:59'!
renderContentWithFrameOn: html

	html div id: 'close-form-frame'; 
		with: [html anchor callback: [orbeonFrame := nil]; 
			with: [html image url: (SEWAFIconLibrary / #symboldeleteiconPng);
													title: ('Close Form' translateFor: self session user);
													altText: ('Close Form' translateFor: self session user)]].
	html div id: 'orbeon-form-frame'; 
		with: [html div id: 'orbeon-form'; with: [html iframe url: orbeonFrame]].! !

!WAEmbeddedProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/27/2015 14:58'!
renderEmbeddedProcessAssignmentOn: html

	selectedLateralItem ifNil: [^self].

	html div id: 'process-assignment-description'; 
		with: [self renderItemDescriptionOn: html.].

	html horizontalRule.! !

WAOrbeonProcessBrowser subclass: #WALinkedProcessBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWeb'!

!WALinkedProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/11/2015 08:49'!
linkToOrbeonFormFor: aBpmArtifactInstance
	"The receiver gives the control to Orbeon Java application."
	| uuid |

	uuid  := OrbeonTempServiceRegistry default 
					createEntryToOrbeonFor: aBpmArtifactInstance 
					for: self session user.

	^self requestContext redirectTo: (self getUrlFor: aBpmArtifactInstance with: uuid).! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 02/03/2016 09:42'!
buildEditUrlFor: aBpmArtifactInstance with: anUUID
	"Answer a string Link to EDIT the Orbeon Form associated with the transition <aBpmArtifactInstance> using the security token <anUUID>"
	| formDefinition |

	formDefinition := aBpmArtifactInstance getDefinitionName.

	^self getOrbeonWebServerConfiguration orbeonIP,'/orbeon/fr/', aBpmArtifactInstance applicationName ,'/',formDefinition,'/edit/', aBpmArtifactInstance getOrbeonFormId,'?token=', anUUID,'&s=', self session key,'&k=', seasideK, '&oop=', aBpmArtifactInstance asOop printString, '&oop2=', selectedLateralItem asOop printString! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 02/03/2016 09:42'!
buildNewUrlFor: aBpmArtifactInstance with: anUUID
	"Answer a string Link to NEW Orbeon Form associated with the transition <aBpmArtifactInstance> using the security token <anUUID>"
	| formDefinition |

	formDefinition := aBpmArtifactInstance getDefinitionName.

	^self getOrbeonWebServerConfiguration orbeonIP, '/orbeon/fr/', aBpmArtifactInstance applicationName ,'/',formDefinition, '/new?token=', anUUID,'&s=', self session key,'&k=', seasideK, '&oop=', aBpmArtifactInstance asOop printString, '&oop2=', selectedLateralItem asOop printString! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 02/03/2016 09:42'!
buildPDFUrlFor: aBpmArtifactInstance with: anUUID
	"Answer a string Link to PDF the Orbeon Form associated with the transition <aBpmArtifactInstance> using the security token <anUUID>"
	| formDefinition |

	formDefinition := aBpmArtifactInstance getDefinitionName.

	^self getOrbeonWebServerConfiguration orbeonIP,'/orbeon/fr/', aBpmArtifactInstance applicationName ,'/',formDefinition,'/pdf/', aBpmArtifactInstance getOrbeonFormId,'?token=', anUUID,'&s=', self session key,'&k=', seasideK, '&oop=', aBpmArtifactInstance asOop printString, '&oop2=', selectedLateralItem asOop printString! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 02/03/2016 09:42'!
buildViewUrlFor: aBpmArtifactInstance with: anUUID
	"Answer a string Link to VIEW the Orbeon Form associated with the transition <aBpmArtifactInstance> using the security token <anUUID>"
	| formDefinition |

	formDefinition := aBpmArtifactInstance getDefinitionName.

	^self getOrbeonWebServerConfiguration orbeonIP,'/orbeon/fr/', aBpmArtifactInstance applicationName ,'/',formDefinition,'/view/', aBpmArtifactInstance getOrbeonFormId,'?token=', anUUID,'&s=', self session key,'&k=', seasideK, '&oop=', aBpmArtifactInstance asOop printString, '&oop2=', selectedLateralItem asOop printString! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 01/18/2016 15:42'!
closeAndSendForm: aBpmArtifactInstance
	"After filling the form the user has clicked on close and send.
	The form can not be edited again."

	self session user finalizeAssignment: selectedLateralItem.

	self removeSelectionAndRefreshLateralCollection.! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/11/2015 08:41'!
collapseIconFor: aBpmArtifactInstance

	((transitionsHeight includesKey: aBpmArtifactInstance) and: [(transitionsHeight at: aBpmArtifactInstance) = #collapsed])
	ifTrue: [^#circledown16Png].

	^#circleup16Png! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/11/2015 08:41'!
collapseTitleFor: aBpmArtifactInstance

	((transitionsHeight includesKey: aBpmArtifactInstance) and: [(transitionsHeight at: aBpmArtifactInstance) = #expanded]) 
	ifFalse: [^'Expand' translateFor: self session user].

	^'Collapse' translateFor: self session user! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 02/24/2016 08:44'!
createOrbeonLinkOn: html for: aBpmArtifactInstance

	html anchor callback: [self linkToOrbeonFormFor: aBpmArtifactInstance]; 
						with: [html image url: (SEWAFIconLibrary / (self iconFor: aBpmArtifactInstance));
													title: (self imageTitleFor: aBpmArtifactInstance);
													altText: (self imageTitleFor: aBpmArtifactInstance)].

	(aBpmArtifactInstance hasForm and:[(aBpmArtifactInstance isGrantedUser: self session user)])
	ifTrue: [ html anchor callback: [self linkToOrbeonPdfFor: aBpmArtifactInstance];
							target: '_blank'; "open the PDF in a new tab or page"
							with: [html image url: (SEWAFIconLibrary / #pdf32Png);
														title: ('View PDF' translateFor: self session user);
														altText: ('View PDF' translateFor: self session user)].
	]
	"if the transition is done and has expected results --> we render an icon to show results summary"

"	(anOrbeonFormTransition isDone and:[anOrbeonFormTransition hasExpectedResult])
	ifTrue: [self renderExpectedResultIcon: html for: anOrbeonFormTransition]"! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 12/13/2015 14:56'!
createSeasideLinkOn: html for: aBpmArtifactInstance

	html anchor callback: [self linkToSeasideComponentFor: aBpmArtifactInstance]; 
						with: [html image url: (SEWAFIconLibrary / (self iconFor: aBpmArtifactInstance));
													title: (self imageTitleFor: aBpmArtifactInstance);
													altText: (self imageTitleFor: aBpmArtifactInstance)].! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/11/2015 08:41'!
displayModeFor: aBpmArtifactInstance

	^transitionsHeight at: aBpmArtifactInstance ifAbsent: [#expanded]! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 03/06/2016 17:14'!
downloadProcessMap

	^self downloadProcessMapOf: self selectedLateralItem! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 03/06/2016 17:15'!
downloadProcessMapOf: aBpmProcessDefinition
	| stream |

	stream := PrintStream on: String new.

	stream nextPutAll: '<?xml version="1.0" encoding="utf-8"?>', String lf, aBpmProcessDefinition process generateProcessMap prettyPrinted.

	self requestContext respond: [:response | 
        response document: ((stream contents asByteArray seasideMimeDocument) 
                                        mimeType: 'application/csv'; 
                                        fileName: (aBpmProcessDefinition processName, '.xpdl'); 
                                        yourself)].

	aBpmProcessDefinition subProcess do: [:each | self downloadProcessMapOf: each]! !

!WAOrbeonProcessBrowser methodsFor: 'categories' stamp: 'BrunoBB 12/14/2015 11:54'!
filterProcessDefinitionByCategory: aBpmProcessInstanceCategory

	searchApplied := true.
	searchResult := self getIterationCollection select: [:each | aBpmProcessInstanceCategory includes: each]! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 12/14/2015 10:44'!
freeSelectedAssignment

	self session user untake: selectedLateralItem.

	lateralCollection remove: selectedLateralItem ifAbsent: [].
	searchResult remove: selectedLateralItem ifAbsent: [].

	selectedLateralItem := nil.

	self getCurrentCollection.! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 03/08/2016 10:49'!
getAllAssignmentsFor: procName in: appName
	"Answer a collection of <OrbeonProcessAssignment> for the process named <procName> in application <appName>"
	| selectBlock |

	appName isEmpty ifTrue: [^searchResult := self getIterationCollection].

	selectBlock := (procName = self viewAllText)
		ifTrue: [[:each | each applicationName = appName]]
		ifFalse: [[:each | each applicationName = appName and: [each processName = procName]]].

	searchResult := self getIterationCollection select: selectBlock! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/15/2015 10:08'!
getAllTasks

	selectedLateralItem ifNil: [^#()].

	self modeIsFinishedTasks ifFalse: [^selectedLateralItem getExecutedArtifacts, selectedLateralItem getRunningArtifacts].

	^OrderedCollection with: selectedLateralItem task! !

!WAOrbeonProcessBrowser methodsFor: 'lateral assignment' stamp: 'BrunoBB 12/12/2015 12:48'!
getCurrentCollection

	searchApplied ifFalse: [^lateralCollection].

	^searchResult! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 02/17/2016 11:00'!
getFormDefinitionList
	"The receiver answer a collection with all form definitions of the selected process type at <searchValues> 'process-type'"
	| procDef |

	procDef := self getSelectedProcessDefinitionOrNil.

	procDef ifNil: [^#()].

	^self viewAllArray, procDef getTaskNames asSet asSortedCollection! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 02/19/2016 13:38'!
getFormFieldList
	"The receiver answer a collection with all field names (removing layer mandatory fields -s,k,oop,uuid-) of the form type in <searchValues> 'form-type' "
	| selectedTask fieldList |

	selectedTask := self getSelectedTaskOrNil.
	selectedTask ifNil: [^#()].

	fieldList := #(''), selectedTask getObjectModel searchFields.

	^(fieldList remove: 'k' ifAbsent: []; 
			remove: 's' ifAbsent: [];
			remove: 'oop' ifAbsent: [];
			remove: 'uuid' ifAbsent: [];
			yourself) asSortedCollection! !

!WAOrbeonProcessBrowser methodsFor: 'lateral assignment' stamp: 'BrunoBB 10/22/2015 16:17'!
getIconNameFormItem 

	^#pageprocess32Png! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 03/08/2016 10:30'!
getIterationCollection
	"Get the iteration collection where the search process will iterate over to find a specific element"

	self modeIsFinishedTasks ifTrue: [^self session user finishedAssignments asArray].

	^lateralCollection! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 02/25/2016 12:38'!
getSelectedApplicationOrNil

	^self getApplicationManagerClass getAnyApplicationNamed: (searchValues at: 'application' ifAbsent: '') ifNone: [nil]! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 02/17/2016 13:05'!
getSelectedProcessDefinitionOrNil
	| definitions |

	definitions := BpmProcessDefinition 
							getProcessesNamed: (searchValues at: 'process-type' ifAbsent: ['']) 
							in: (searchValues at: 'application' ifAbsent: ['']).

	definitions ifNil: [^nil].

	^definitions isEmpty ifFalse: [definitions last] ifTrue: [nil]! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 02/17/2016 11:08'!
getSelectedTaskOrNil
	"The receiver answer the current selected task (orbeon form definition or st model) or nil"

	^self getSelectedProcessDefinitionOrNil
		ifNil: [nil]
		ifNotNil: [:procDefinition | procDefinition getTaskNamed: (searchValues at: 'form-type' ifAbsent: ['']) ifNone: [nil]]! !

!WAOrbeonProcessBrowser methodsFor: 'lateral assignment' stamp: 'BrunoBB 10/22/2015 16:17'!
getTextForItem: aLateralListItem

	^aLateralListItem processName! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 12/11/2015 08:39'!
getUrlFor: aBpmArtifactInstance with: anUUID
	"Generate an url link to Java Orbeon application with context execution parameters (that are stored as hidden in the Java Orbeon Form) so the Java Application can return back to this web page with an updated domain model"
	| formDefinition |

	formDefinition := aBpmArtifactInstance getDefinitionName. "name of the form to link"
	^aBpmArtifactInstance hasForm "is a new or an edited form ?"
		ifFalse: [(aBpmArtifactInstance isGrantedUser: self session user) "has permissions ?"
					ifTrue: [self buildNewUrlFor: aBpmArtifactInstance with: anUUID]] "Orbeon NEW link"
		ifTrue: [(aBpmArtifactInstance isDone or:[(aBpmArtifactInstance isGrantedUser: self session user) not])
			ifFalse: [self buildEditUrlFor: aBpmArtifactInstance with: anUUID] "Orbeon EDIT link"
			ifTrue: [self buildViewUrlFor: aBpmArtifactInstance with: anUUID]] "Orbeon VIEW link"! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 12/15/2015 09:25'!
iconFor: aBpmArtifactInstance

	aBpmArtifactInstance isCreated ifFalse: [^#pageprocess32Png].
	aBpmArtifactInstance isDone ifTrue:[^#processacceptPng].
	aBpmArtifactInstance isDone ifTrue: [^#pageaccept32Png].
	aBpmArtifactInstance isProcessing ifTrue: [^#documentediticonPng].
"	aBpmArtifactInstance isPaused ifTrue: [^#stopwatchpausePng].
	aBpmArtifactInstance isDelayed ifTrue: [^#clockPng].
	aBpmArtifactInstance isPending ifTrue: [^#aquastrippedfolderclockPng]."

	^#documentediticonPng! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 12/15/2015 09:26'!
imageTitleFor: aBpmArtifactInstance

	aBpmArtifactInstance isCreated ifFalse: [^'Create Task' translateFor: self session user].
	aBpmArtifactInstance isDone ifTrue:[^'Finished Task' translateFor: self session user].
	aBpmArtifactInstance isProcessing ifTrue: [^'Edit Task' translateFor: self session user].
"	aBpmArtifactInstance isPaused ifTrue: [^'Paused' translateFor: self session user].
	aBpmArtifactInstance isDelayed ifTrue: [^'Delayed' translateFor: self session user].
	aBpmArtifactInstance isPending ifTrue: [^'Pending' translateFor: self session user]."

	^'Undefined' translateFor: self session user! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 15:39'!
initialize

	super initialize.

	searchAvailable := false.
	mode := #normal.
	categories := OrderedCollection new.
	transitionsHeight := Dictionary new.

	self setShowToElementNamed: 'search-area'. "the search-are is shown by default"

	batchedList := SewafLateralBatchedList parentComponent: self.
	batchedList batchSize: 5;
		navigationCssClass: 'batch-div-lateral-top'.! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 03/05/2016 11:02'!
isRangeSearch

	^(searchValues at: 'field-value-2' ifAbsent: [^false]) notNil! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 12/11/2015 08:40'!
linkToOrbeonFormFor: aBpmArtifactInstance
	"The receiver gives the control to Orbeon Java application."

	self subclassResponsibility! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 12/21/2015 12:22'!
linkToOrbeonPdfFor: aBpmArtifactInstance
	| uuid |

	uuid  := OrbeonTempServiceRegistry default 
					createEntryToOrbeonFor: aBpmArtifactInstance 
					for: self session user.

	^self requestContext redirectTo: (self buildPDFUrlFor: aBpmArtifactInstance with: uuid)! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 02/19/2016 13:39'!
linkToSeasideComponentFor: aBpmSeasideTaskInstance
  "The receiver gives the control to the component of task <aBpmSeasideTaskInstance>."
  | seasideModel |

  aBpmSeasideTaskInstance
    externalObject:
      (aBpmSeasideTaskInstance hasForm
        ifTrue: [aBpmSeasideTaskInstance externalObject]
        ifFalse: [aBpmSeasideTaskInstance getObjectModel]).

  seasideModel := aBpmSeasideTaskInstance externalObject.

  self show: (aBpmSeasideTaskInstance getComponentClass 
						newOn: seasideModel 
						task: aBpmSeasideTaskInstance 
						assignment: selectedLateralItem)! !

!WAOrbeonProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 10/22/2015 16:17'!
mode
	^mode! !

!WAOrbeonProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 10/22/2015 16:17'!
mode: newValue
	"Set the mode of the receiver (#finished or #normal). 
	normal - is when lateral list is composed with current pending assignments.
	finished - is when lateral list is composed with finished assignments.
	If <mode> is different from <newValue> --> the sub menu has changed the <selectedLateralItem> must be reseted"

	(mode == newValue) ifFalse: [selectedLateralItem := nil].

	mode := newValue! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 12/15/2015 10:05'!
modeIsFinishedTasks

	^mode = #finished! !

!WAOrbeonProcessBrowser methodsFor: 'categories' stamp: 'BrunoBB 12/13/2015 11:56'!
onProcessCategoryClicked: aProcessInstanceUserCategory

	self hasSelectedLateralItem ifFalse: [^self filterProcessDefinitionByCategory: aProcessInstanceUserCategory].

	(aProcessInstanceUserCategory includes: selectedLateralItem)
	ifTrue: [aProcessInstanceUserCategory remove: selectedLateralItem]
	ifFalse: [aProcessInstanceUserCategory add: selectedLateralItem]! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 10/22/2015 16:17'!
registerProcessType: value

	searchValues at: 'process-type' put: value. 
	searchValues removeKey: 'form-type' ifAbsent: [].
	searchValues removeKey: 'field-name' ifAbsent: [].
	searchValues removeKey: 'field-value' ifAbsent: [].! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 01/18/2016 10:25'!
removeSelectionAndRefreshLateralCollection

	lateralCollection remove: selectedLateralItem ifAbsent: [].
	searchResult remove: selectedLateralItem ifAbsent: [].

	selectedLateralItem := nil.

	self getCurrentCollection.! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 02/08/2016 12:33'!
renderApplicationComboOn: html

	html label 
		attributeAt: 'for' put: 'application';
		with: ('Application' translateFor: self session user).
	html select "Process Definition List"
		attributeAt: 'id' put: 'application';
		list: (#(''), (self session user getApplications collect: [:each | each applicationName])) asSet asSortedCollection;
		onChange: 'submit()';
		callback: [:value | searchValues at: 'application' put: value];
		selected: (searchValues at: 'application' ifAbsent: ['']).! !

!WAOrbeonProcessBrowser methodsFor: 'categories' stamp: 'BrunoBB 10/22/2015 16:17'!
renderCategoriesListOn: html

	categories do: [:each | 
		html anchor callback: [self onProcessCategoryClicked: each]; 
			class: 'category-label';
			style: 'background-color:', each color;
			with: [html output: each name]].! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 01/18/2016 16:29'!
renderCloseAndSendFormOn: html for: aBpmArtifactInstance

	aBpmArtifactInstance isDone ifTrue: [^self].

	aBpmArtifactInstance isCreated ifFalse: [^self].
	(aBpmArtifactInstance isGrantedUser: self session user) ifFalse: [^self].

	(aBpmArtifactInstance canCloseAndSend or: [aBpmArtifactInstance hasPerformers])
		ifTrue: [self renderCloseAndSendIconOn: html for: aBpmArtifactInstance
		]! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 01/18/2016 16:28'!
renderCloseAndSendIconOn: html for: aBpmArtifactInstance
	| symbolIcon |

	symbolIcon := aBpmArtifactInstance isFinishedByPerformers ifFalse: [#tasksicon32Png] ifTrue: [#emailsendiconPng].

	html anchor callback: [self closeAndSendForm: aBpmArtifactInstance]; 
								with: [html image url: (SEWAFIconLibrary / symbolIcon); 
														title: ('Close & Send Form' translateFor: self session user);
														altText: ('Close & Send Form' translateFor: self session user)]! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 10/22/2015 16:17'!
renderContentOn: html

	seasideK := self session requestContext request at: '_k' ifAbsent: ['error'].

	super renderContentOn: html.! !

!WAOrbeonProcessBrowser methodsFor: 'categories' stamp: 'BrunoBB 12/13/2015 12:03'!
renderCustomItemElementOn: html forItem: aBpmTaskAssignment

	(self session user getProcessInstanceCategoriesFor: aBpmTaskAssignment) do: [:each | 
		html div class: 'category-circle'; style: 'background-color: ', each color;
			with: [html output: each name first].
	].! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 02/17/2016 12:58'!
renderFilterValuesAndButtonOn: html
	| processName procDef formType fieldName fieldType |

	((searchValues includesKey: 'field-name') and:[searchValues includesKey: 'form-type']) ifFalse: [^self renderSearchSubmitButtonOn: html].

	formType := searchValues at: 'form-type'.
	processName := searchValues at: 'process-type'.
	fieldName := searchValues at: 'field-name'.

	procDef := self getSelectedProcessDefinitionOrNil.

	procDef ifNil: [^self renderSearchSubmitButtonOn: html].

	fieldType := procDef getTypeOf: fieldName in: formType ifNone: [^self renderSearchSubmitButtonOn: html].

	((OrderedCollection with: String with: Boolean) includes: fieldType) ifTrue: [^self renderOneFilterOn: html].

	^self renderTwoFitersOn: html.! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 12/11/2015 06:50'!
renderFormDataOn: html for: aBpmActivityInstance

	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('User' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: aBpmActivityInstance getUserName]].
	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('State' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: (aBpmActivityInstance printState translateFor: self session user)]].
"	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('Previous Form' translateFor: self session user)].
		html strong with: [html output  with: (aBpmActivityInstance getDefinitionName translateFor: self session user)]]."
	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('Form to Fill' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: aBpmActivityInstance getDefinitionName]].
	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('Initial Date' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: aBpmActivityInstance creationTime]].
	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('Not Implemented' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: aBpmActivityInstance creationTime]].! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 10/22/2015 16:17'!
renderFormDefinitionComboOn: html

	html label 
		attributeAt: 'for' put: 'formDefinitions';
		with: ('Form' translateFor: self session user).

	html select "Form Definition List" 
		attributeAt: 'id' put: 'formDefinitions';
		class: 'search-section-width-200';
		list: ((searchValues includesKey: 'process-type') 
				ifFalse: [#()] 
				ifTrue: [self getFormDefinitionList]);
		onChange: 'submit()';
		callback: [:value | searchValues at: 'form-type' put: value];
		selected: (searchValues at: 'form-type' ifAbsent: ['']).! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 10/22/2015 16:17'!
renderFormFieldComboOn: html

	html label 
		attributeAt: 'for' put: 'formFields';
		with: ('Field' translateFor: self session user).

	html select "Field Definition List" 
		attributeAt: 'id' put: 'formFields';
		class: 'search-section-width-200';
		list: self getFormFieldList;
		onChange: 'submit()';
		callback: [:value | searchValues at: 'field-name' put: value];
		selected: (searchValues at: 'field-name' ifAbsent: ['']).! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 12/15/2015 10:04'!
renderItemComponentOn: html
	| heightClass |

	self getAllTasks do:[:eachArtifact | | cssClass |
		cssClass := eachArtifact isTask 
			ifFalse: ['process-transition-gateway']
			ifTrue: [eachArtifact isDone
				ifTrue: ['process-transition-finished']
				ifFalse: ['process-transition-running']].

		heightClass := ((transitionsHeight at: eachArtifact ifAbsent: [#expanded]) = #expanded) 
								ifTrue: ['process-transition-expanded'] 
								ifFalse: ['process-transition-collapsed'].

		html div class: (cssClass, ' ', heightClass); with: [
			self renderTransitionDataOn: html for: eachArtifact].
	]. "end DO"! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 12/18/2015 15:26'!
renderItemDescriptionAditionalDataOn: html

	html span with: [html strong: ('Assigned Date:' translateFor: self session user)].
	html output: selectedLateralItem printAssignmentDate.
	html span: [html strong: ('Current Forms:' translateFor: self session user)].
	html output: selectedLateralItem printRunningArtifacts.
	html span: [html strong: ('Process Creator:' translateFor: self session user)].
	html output: selectedLateralItem printCreatorName.
	html span: [html strong: ('Can Unassign:' translateFor: self session user)]. 
	html output: (selectedLateralItem canUnassign printString translateFor: self session user).! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 12/18/2015 15:26'!
renderItemDescriptionSecondaryDataOn: html

	html span with: [html strong: ('Application:' translateFor: self session user)].
	html output: selectedLateralItem applicationName.
	html span with: [html strong: ('Process Id:' translateFor: self session user)].
	html output: selectedLateralItem processId.
	html span: [html strong: ('Version:' translateFor: self session user)]. 
	html output: selectedLateralItem version.
	html span: [html strong: ('Process State:' translateFor: self session user)].
	html output: (selectedLateralItem printProcessState translateFor: self session user).! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 12/14/2015 10:43'!
renderItemDescriptionTitleOn: html
	"The receiver render the summary of the object selected on the Lateral List "

	html output:  selectedLateralItem processName. "process name"
	selectedLateralItem isInCorruptedState 
	ifTrue: [html span with: [html strong: ('(Corrupted)' translateFor: self session user)]].

	selectedLateralItem hasFinalized
	ifFalse: [
		html anchor 
			callback: [self freeSelectedAssignment]; 
			with: [html image url: (SEWAFIconLibrary / #gointo24Png); 
						title: ('Free Process' translateFor: self session user);
						altText: ('Free Process' translateFor: self session user)]].

	html anchor 
		callback: [self downloadProcessMap]; 
		with: [html image url: (SEWAFIconLibrary / #documentflowchart24Png); 
					title: ('Process Map' translateFor: self session user);
					altText: ('Process Map' translateFor: self session user)].! !

!WAOrbeonProcessBrowser methodsFor: 'lateral assignment' stamp: 'BrunoBB 12/10/2015 13:14'!
renderLateralItemDetailsOn: html for: aLateralItem

	html strong with: [html output: aLateralItem processId].
	html strong with: [html output: aLateralItem printAssignmentDate].
	html strong with: [html output: aLateralItem printRunningArtifacts]! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 02/22/2016 12:51'!
renderOneFilterOn: html

	searchValues at: 'field-value-2' put: nil. "clean the second value --> is not going to be used"

	html label 
		attributeAt: 'for' put: 'filterOne';
		class: 'search-section-float'; with: ('Field Value' translateFor: self session user).

	html textInput 
		attributeAt: 'id' put: 'filterOne';
		class: 'search-section-float search-section-width-200';
		callback: [:value | searchValues at: 'field-value' put: value];
		with: (searchValues at: 'field-value' ifAbsent: ['']).

	self renderSearchSubmitButtonOn: html.! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 12/13/2015 14:51'!
renderOrbeonLinkIconOn: html for: aBpmOrbeonTaskInstance

	"a granted user with edit permission"
	(aBpmOrbeonTaskInstance isGrantedUser: self session user) 
	ifTrue: [^self createOrbeonLinkOn: html for: aBpmOrbeonTaskInstance].
	"a user that has edit permission in other part of the process and does NOT has it this Transition, is granted to READ. 
	If the Form has not been created then there is NOTHING to view"
	((aBpmOrbeonTaskInstance isGrantedUser: self session user) and: [aBpmOrbeonTaskInstance hasForm]) 
	ifTrue: [^self createOrbeonLinkOn: html for: aBpmOrbeonTaskInstance].

	"self createLinkForSeasideComponentOn: "! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 12/10/2015 12:44'!
renderProcessTypeComboOn: html
	| definitionsNames |

	definitionsNames  := (BpmProcessDefinition getAllVersionsIn: (searchValues at: 'application' ifAbsent: [''])) collect: [:each | each processName].

	html label 
		attributeAt: 'for' put: 'processType';
		with: ('Process Type' translateFor: self session user).

	html select "Process Definition List"
		attributeAt: 'id' put: 'processType';
		list: self viewAllArray, definitionsNames
"(lateralCollection collect: [:each | each formProcessDefinition name]) asSet asSortedCollection";
		onChange: 'submit()';
		callback: [:value | self registerProcessType: value];
		selected: (searchValues at: 'process-type' ifAbsent: ['']).! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 03/06/2016 15:44'!
renderSearchAreaOn: html

	self renderShowHideWindowIconOn: html. "show/hide search area"

	(self isEnabledToShowElementNamed: 'search-area') ifFalse: [^self].

	self searchPanelIsRegular 
	ifTrue: [self renderSearchRegularPanelOn: html]
	ifFalse: [self renderSearchCategoriesPanelOn: html].! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 10/22/2015 16:17'!
renderSearchCategoriesPanelOn: html

	html form with: [ 
		html fieldSet with: [
			self renderSwitchWindowOn: html.
			html label attributeAt: 'for' put: 'categotyLabel'; with: ('Category Name' translateFor: self session user).
			html textInput attributeAt: 'id' put: 'categotyLabel'; callback: [:value | searchValues at: 'category-name' put: value].
			self renderCategoriesListOn: html.
			html div id: 'top-search-filters'; with: [
				html submitButton class: 'search-section-float search-section-width-100';
					callback: [self searchMatchingCategories]; 
					with: ('Search' translateFor: self session user).].
		].
].! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 03/06/2016 14:58'!
renderSearchRegularPanelOn: html

	html form with: [ 
		html fieldSet with: [
			self renderSwitchWindowOn: html.
			html label attributeAt: 'for' put: 'processId'; with: ('Process Id' translateFor: self session user).
			html textInput attributeAt: 'id' put: 'processId'; callback: [:value | searchValues at: 'id' put: value].
			self renderApplicationComboOn: html.
			self renderProcessTypeComboOn: html.
			self renderFormDefinitionComboOn: html.
			self renderFormFieldComboOn: html.
			html div id: 'top-search-filters'; with: [
				"self renderTwoFitersOn: html."
				self renderFilterValuesAndButtonOn: html].
		].
]! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 10/22/2015 16:17'!
renderSearchSubmitButtonOn: html

	html submitButton 
		class: 'search-section-float search-section-width-100';
		callback: [self searchMatchingProcesses]; 
		with: ('Search' translateFor: self session user).! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 12/15/2015 12:14'!
renderSeasideFormLinkIconOn: html for: aBpmSeasideTaskInstance

	"a granted user with edit permission"
	(aBpmSeasideTaskInstance isGrantedUser: self session user) 
	ifTrue: [^self createSeasideLinkOn: html for: aBpmSeasideTaskInstance].! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 03/06/2016 15:18'!
renderShowHideWindowIconOn: html
	| iconSymbol |

	iconSymbol := (self isEnabledToShowElementNamed: 'search-area') ifTrue:[#arrowsupcircular16Png] ifFalse: [#arrowsdowncircular16Png].

	html div id: 'top-search-show-hide-area'; with: [
		html anchor 
			callback: [self switchShowHideValueToElementNamed: 'search-area'];
			with: [
				html div with: [
					html image url: (SEWAFIconLibrary / iconSymbol); 
						altText: ('Show Hide Search Area' translateFor: self session user); 
						title: ('Show Hide Search Area' translateFor: self session user).
				].
		].
	].! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 03/06/2016 15:13'!
renderSwitchWindowOn: html

	html div id: 'top-search-switch-icon'; with: [
		html anchor 
			callback: [searchPanelName := (searchPanelName = #search) ifTrue: [#categories] ifFalse: [#search]];
			with: [
				html div with: [
					html image url: (SEWAFIconLibrary / #ezswitchuser16Png); 
						altText: ('Switch Window' translateFor: self session user); 
						title: ('Switch Window' translateFor: self session user).
				].
		].
	].! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 12/14/2015 15:24'!
renderTransitionActionsOn: html for: aBpmArtifactInstance

	aBpmArtifactInstance isTask ifFalse: [^self].

	aBpmArtifactInstance renderHtmlOn: html for: self.

	(aBpmArtifactInstance isSubprocess not and: [aBpmArtifactInstance isDone not])
		ifTrue: [self renderCloseAndSendFormOn: html for: aBpmArtifactInstance.].! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 12/11/2015 06:43'!
renderTransitionDataOn: html for: aBpmArtifactInstance

	html anchor class: 'process-transition-icon-collapse';
		callback: [self switchOpenCloseTransition: aBpmArtifactInstance]; 
		with: [html image url: (SEWAFIconLibrary / (self collapseIconFor: aBpmArtifactInstance));
								title: (self collapseTitleFor: aBpmArtifactInstance);
								altText: (self collapseTitleFor: aBpmArtifactInstance)].

	html header with: [html strong: aBpmArtifactInstance printFormLargeNameForWebButton].
	html header with: [html strong: ('Transition Data' translateFor: self session user)].

	((self displayModeFor: aBpmArtifactInstance) = #collapsed) ifTrue: [^self].

	aBpmArtifactInstance isTask 
	ifTrue: [^self renderTransitionFormDataOn: html for: aBpmArtifactInstance].

	aBpmArtifactInstance isSubprocessDefinition
	ifTrue: [^self renderTransitionSubProcessDataOn: html for: aBpmArtifactInstance].

	^self renderTransitionGatewayDataOn: html for: aBpmArtifactInstance! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 12/11/2015 08:47'!
renderTransitionFormDataOn: html for: aBpmArtifactInstance

	self renderFormDataOn: html for: aBpmArtifactInstance.

	self renderTransitionSummaryOn: html for: aBpmArtifactInstance.
	self renderTransitionActionsOn: html for: aBpmArtifactInstance.! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 12/11/2015 08:47'!
renderTransitionGatewayDataOn: html for: aBpmArtifactInstance

	aBpmArtifactInstance triggeredGateway ifNotNil: [:gateway |
		gateway outgoingTransitions do: [:transition |  
			html div class: 'transition-data'; with: [
				html strong with: [html span with: ('Condition' translateFor: self session user)].
				html strong with: [html output with: transition getStartConditionsString]].
			html div class: 'transition-data'; with: [
				html strong with: [html span with: ('Next Form' translateFor: self session user)].
				html strong with: [html output with: transition endFormName]].
		]
	].! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 12/11/2015 06:51'!
renderTransitionSubProcessDataOn: html for: aBpmArtifactInstance

	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('User' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: aBpmArtifactInstance getUserName]].
	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('State' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: (aBpmArtifactInstance printState translateFor: self session user)]].
	"html div class: 'transition-data'; with: [
		html strong with: [html span with: ('Previous Form' translateFor: self session user)].
		html strong with: [html output with: (anOrbeonFormTransition startFormName translateFor: self session user)]]."
	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('Form to Fill' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: aBpmArtifactInstance getDefinitionName]].
	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('Initial Date' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: aBpmArtifactInstance creationTime]].
	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('Not implemented' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: aBpmArtifactInstance creationTime]].

	self renderTransitionSummaryOn: html for: aBpmArtifactInstance.
	self renderTransitionActionsOn: html for: aBpmArtifactInstance.! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 12/11/2015 08:48'!
renderTransitionSummaryOn: html for: aBpmArtifactInstance

	html header with: [html strong: (aBpmArtifactInstance summaryTitle translateFor: self session user)].

	aBpmArtifactInstance getSummaryFieldsValues keysAndValuesDo: [:key :value | 
		html div class: 'transition-data'; with: [
			html strong with: [html span with: key].
			html strong with: [html output with: value]]].! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 10/22/2015 16:17'!
renderTwoFitersOn: html

	html label 
		attributeAt: 'for' put: 'filterOne';
		class: 'search-section-float'; 
		with: ('Start Value' translateFor: self session user).
	html textInput 
		attributeAt: 'id' put: 'filterOne';
		class: 'search-section-float search-section-width-200';
		callback: [:value | searchValues at: 'field-value' put: value];
		with: (searchValues at: 'field-value' ifAbsent: ['']).
	html label 
		attributeAt: 'for' put: 'filterTwo';
		class: 'search-section-float'; 
		with: ('End Value' translateFor: self session user).
	html textInput 
		attributeAt: 'id' put: 'filterTwo';
		class: 'search-section-float search-section-width-200';
		callback: [:value | searchValues at: 'field-value-2' put: value];
		with: (searchValues at: 'field-value-2' ifAbsent: ['']).

	self renderSearchSubmitButtonOn: html.! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 10/22/2015 16:17'!
searchByProcessId
	| id |

	id  := searchValues at: 'id' ifAbsent: [''].

	searchResult := self getIterationCollection select: [:each | each processId printString = id].

	selectedLateralItem := nil.
	"selectedTransition := nil."

	searchValues removeKey: 'id' ifAbsent: [''].! !

!WAOrbeonProcessBrowser methodsFor: 'categories' stamp: 'BrunoBB 12/13/2015 12:07'!
searchMatchingCategories

	categories := (BpmProcessInstanceCategory getCategoriesFor: self session user) select: [:each | 
		(searchValues at: 'category-name' ifAbsent: ['']) match: each name].! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 03/07/2016 13:31'!
searchMatchingProcesses
	"Answer a collection of <OrbeonProcessAssignment> that match the search criteria in receiver's web interface.
	The fast search performed against a field name and a field value in a Form (<formName>, <fieldName> and <fieldValue>). 
	If these values are not specified then answer a collection of <OrbeonProcessAssignment> for the process name <procName> in application <appName>"
	| appName procName formName fieldName fieldValue fieldValue2 |

	searchApplied := true.
	((searchValues includesKey: 'id') and:[(searchValues at: 'id') notEmpty]) ifTrue: [^self searchByProcessId].

	selectedLateralItem := nil.

	appName := searchValues at: 'application' ifAbsent: [''].
	procName := searchValues at: 'process-type' ifAbsent: [''].
	formName := searchValues at: 'form-type' ifAbsent: ['']. (formName = self viewAllText) ifTrue: [formName := ''].
	fieldName  := searchValues at: 'field-name' ifAbsent: [''].
	fieldValue  := searchValues at: 'field-value' ifAbsent: [''].
	fieldValue2 := searchValues at: 'field-value-2' ifAbsent: [''].

	(formName isEmpty and: [fieldName isEmpty and: [fieldValue isEmpty]]) 
	ifTrue: [^self getAllAssignmentsFor: procName in: appName].

	searchResult := self isRangeSearch
		ifFalse: [BpmProcessDefinition getAssignmentsIn: appName processName: procName formName: formName fieldName: fieldName withValue: fieldValue]
		ifTrue: [BpmProcessDefinition getAssignmentsIn: appName processName: procName formName: formName fieldName: fieldName initialValue: fieldValue endValue: fieldValue2].

	searchResult := self modeIsFinishedTasks 
		ifFalse: [searchResult reject: [:each | each hasFinalized]] 
		ifTrue: [searchResult select: [:each | each hasFinalized]]! !

!WAOrbeonProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 10/22/2015 16:17'!
seasideK
	^seasideK! !

!WAOrbeonProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 10/22/2015 16:17'!
seasideK: newValue
	seasideK := newValue! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 10/22/2015 18:35'!
selectedLateralItem: newValue
	| oldAssignment |

	oldAssignment := selectedLateralItem.
	selectedLateralItem := newValue.

	(newValue notNil and: [oldAssignment ~~ selectedLateralItem])
	ifTrue: [self setTransitionsHeight].! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/15/2015 10:04'!
setTransitionsHeight

	transitionsHeight := Dictionary new.

	self getAllTasks do: [:each | 
		self session user transitionDisplayModeIsExpanded
		ifTrue: [transitionsHeight at: each put: #expanded]
		ifFalse: [transitionsHeight at: each put: #collapsed]].

	^transitionsHeight! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/11/2015 08:42'!
switchOpenCloseTransition: aBpmArtifactInstance

	((transitionsHeight includesKey: aBpmArtifactInstance) and: [(transitionsHeight at: aBpmArtifactInstance) = #expanded])
	ifTrue: [transitionsHeight at: aBpmArtifactInstance put: #collapsed]
	ifFalse: [transitionsHeight at: aBpmArtifactInstance put: #expanded]! !

SEWAFApplicationPortal subclass: #WAProcessUserPortal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWeb'!

!WAProcessUserPortal methodsFor: 'other' stamp: 'BrunoBB 06/27/2015 09:28'!
applicationIcon

	^SEWAFIconLibrary / #documentflowchart48Png! !

!WAProcessUserPortal methodsFor: 'other' stamp: 'BrunoBB 06/27/2015 09:29'!
applicationName

	^'Form Flow'! !

!WAProcessUserPortal methodsFor: 'other' stamp: 'BrunoBB 06/27/2015 09:23'!
getAssignmentComponentClassFor: anOrbeonFormUser
	"Answer the class to use to display User Process Assginments.
	- Can be linked (in a different web page of Smalltalk application).
	- Can be embedded (in the same we page of Smalltalk application)"

	anOrbeonFormUser userOptions orbeonWebIsLinked ifTrue: [^WALinkedProcessBrowser].

	^WAEmbeddedProcessBrowser! !

!WAProcessUserPortal methodsFor: 'other' stamp: 'BrunoBB 06/27/2015 09:23'!
initialize

	super initialize.

	subTabChanged := false.

	self initializeNavigation.! !

!WAProcessUserPortal methodsFor: 'top menu' stamp: 'BrunoBB 03/06/2016 13:42'!
initializeNavigation
	| subMenu1 subMenu2 subMenu3 subMenu4 |

	navigation := SewafPortalMenu new iconLibrary: SEWAFIconLibrary.
	subMenu1 := (SewafSubMenuItem label: 'My Processes' icon: #worksinprogress48Png)
		addItem: (SewafCommandItem label: 'Current Processes' command: #showCurrentProcess);
		addItem: (SewafCommandItem label: 'Finished Processes' command: #showFinishedProcess);
		addItem: (SewafCommandItem label: 'Process Categories' command: #showProcessCategories);
		yourself.
	subMenu2 := (SewafSubMenuItem label: 'Unassigned Tasks' icon: #folderscheduledtasks48Png)
		addItem: (SewafCommandItem label: 'View Unassigned Tasks' command: #showUnassignedTasks);
		yourself.
	subMenu3 := (SewafSubMenuItem label: 'Create Process' icon: #processadd48Png)
		addItem: (SewafCommandItem label: 'Available Processes' command: #showAvailableProcesses);
		addItem: (SewafCommandItem label: 'Granted Transitions' command: #showGrantedTransitions);
		yourself.
	subMenu4 := (SewafSubMenuItem label: 'User Preferences' icon: #applicationsettings48Png)
		addItem: (SewafCommandItem label: 'Change Password' command: #showChangePassword);
		addItem: (SewafCommandItem label: 'Form Display Mode' command: #showFormDisplayMode);
		addItem: (SewafCommandItem label: 'Set Language' command: #showLanguageConfiguration);
		yourself.
	navigation addItem: subMenu1;
		addItem: subMenu2;
		addItem: subMenu3;
		addItem: subMenu4.! !

!WAProcessUserPortal methodsFor: 'other' stamp: 'BrunoBB 02/03/2016 09:43'!
logout

	self session logout.	
	self session unregister.
	self requestContext redirectTo: (self getGemStoneServerConfiguration gemstoneIP, '/orbeonProcess')! !

!WAProcessUserPortal methodsFor: 'other' stamp: 'BrunoBB 03/06/2016 14:03'!
selectedLateralItem: anObject

	arena ifNotNil: [arena selectedLateralItem: anObject].! !

!WAProcessUserPortal methodsFor: 'sub components' stamp: 'BrunoBB 12/16/2015 12:35'!
showAvailableProcesses

	^(arena class == WAOrbeonNewProcessBrowser)
	ifTrue: [arena parent: self collection: self session user getCreationProcesses]
	ifFalse: [WAOrbeonNewProcessBrowser parent: self collection: self session user getCreationProcesses]! !

!WAProcessUserPortal methodsFor: 'sub components' stamp: 'BrunoBB 06/27/2015 09:23'!
showChangePassword

	^FormProcessChangePasswordComposite new! !

!WAProcessUserPortal methodsFor: 'sub components' stamp: 'BrunoBB 03/06/2016 12:42'!
showCurrentProcess

	^self showCurrentProcess: self session user currentAssignments asArray! !

!WAProcessUserPortal methodsFor: 'sub components' stamp: 'BrunoBB 03/06/2016 12:25'!
showCurrentProcess: anOrderedCollection
	| subComponent |

	(arena isKindOf: WAOrbeonProcessBrowser)
	ifTrue: [
		(arena mode = #normal) ifFalse: [arena searchApplied: false].
		arena mode: #normal.
		^arena parent: self collection: anOrderedCollection].

	subComponent := (self getAssignmentComponentClassFor: self session user) 
				parent: self collection: anOrderedCollection.
	
	subComponent mode: #normal; searchApplied: false.

	^subComponent! !

!WAProcessUserPortal methodsFor: 'sub components' stamp: 'BrunoBB 07/06/2015 12:57'!
showFinishedProcess
	| subComponent |

	(arena isKindOf: WAOrbeonProcessBrowser)
	ifTrue: [
		(arena mode = #finished) ifFalse: [arena searchApplied: false].
		arena mode: #finished.
		^arena parent: self collection: OrderedCollection new"self session user finishedAssignments asArray"].

	subComponent := (self getAssignmentComponentClassFor: self session user) 
			parent: self collection: OrderedCollection new "self session user pendingAssignments asArray".

	subComponent mode: #finished; searchApplied: false.

	^subComponent! !

!WAProcessUserPortal methodsFor: 'sub components' stamp: 'BrunoBB 06/27/2015 09:23'!
showFormDisplayMode

	^FormProcessUserPreferenceComposite new! !

!WAProcessUserPortal methodsFor: 'sub components' stamp: 'BrunoBB 03/08/2016 15:03'!
showGrantedTransitions

	(arena isKindOf: WAOrbeonGrantedTransitionManager)
	ifTrue: [^arena].

	^WAOrbeonGrantedTransitionManager parent: self! !

!WAProcessUserPortal methodsFor: 'sub components' stamp: 'BrunoBB 06/27/2015 09:23'!
showLanguageConfiguration

	^UserLanguageComposite new! !

!WAProcessUserPortal methodsFor: 'sub components' stamp: 'BrunoBB 07/05/2015 13:05'!
showProcessCategories

	(arena isKindOf: WAOrbeonProcessCategoryManager)
	ifTrue: [^arena].

	^WAOrbeonProcessCategoryManager parent: self! !

!WAProcessUserPortal methodsFor: 'sub components' stamp: 'BrunoBB 12/08/2015 08:46'!
showUnassignedTasks

	"^WAFreeTransitionBagBrowser new"

	(arena class == WABpmUnassignedTaskBrowser)
	ifFalse: [^WABpmUnassignedTaskBrowser new].

	^arena! !

!WAProcessUserPortal methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 14:32'!
style

^'/* Smart Devices*/
@media (max-width: 800px) {                  
   .smart-hide-width {
      display: none !!important;
   }
}
@media (max-height: 450px) {                  
   .smart-hide-height {
      display: none !!important;
   }
}
/* NEW CSS - REFACTORIZED */
/* START: HTML GENERAL */
body, html, main {
	margin: 0;
	width: 100%;
	height: 100%;
	overflow-y: hidden;
	background-color: #BCBCBC;
}
#screen-all {
	height: 100%;
}
/* END: HTML GENERAL */
/* START: TOP AREA */
#top-area {
	display: inline-flex;
	width: 100%;
	background-color: gray;
	padding-top: 2px;
}
#top-app-icon-area {
	display: inline-flex;
	padding-top: 15px;
	padding-left: 10px;
	width: 20%;
}
#top-app-icon-area h1{
	margin-top: 5px;
	color: gainsboro;
}
#top-logout a {
	text-decoration: none;
}
#top-logout output {
	font-size: 90%;
}
#top-menu-area {
	width: 80%;
	margin-top: 5px;
}
.top-menu-item {
	float: left;
	margin-left: 5%;
}
.top-menu-item a {
	color: white;
	text-decoration: none;
}
.top-menu-item a output {
	font-size: 120%;
}
.top-menu-item img {
	display: block;
	margin-left: auto;
	margin-right: auto;
}
.top-menu-item-triangle {
	border-style: solid;
	border-width: 0px 10px 10px;
	border-color: transparent transparent #D3D3D3;
	color: #FFF;
	width: 0px;
	height: 0px;
	margin-left: auto;
	margin-right: auto;
}
#top-submenu-area {
	height: 40px;
	background-color: lightgray;
}
.top-area-close-icon {
	float: right;
	margin-top: 3px;
	margin-right: 5px;
}
.top-sub-item-selected output {
	font-family: Times New Roman;
	font-size: 20px;
	color: rgb(64, 64, 64);
}
.top-sub-item-selected a, .top-sub-item-unselected a {
	text-decoration: none;
}
.top-sub-item-selected, .top-sub-item-unselected {
	float: left;
	padding-top: 10px;
	margin-left: 10px;
	margin-right: 30px;
}
.top-sub-item-unselected output {
	font-family: Times New Roman;
	font-size: 20px;
	color: #808080;
}
.top-sub-item-selected, .top-sub-item-unselected output:hover {
	color: rgb(64, 64, 64);
}
/* END: TOP AREA */
/* START: BOTTOM AREA */
/* END: BOTTOM AREA */
/* START: COMPONENT AREA */
#component-area {
	background-color: #BCBCBC;
	height: 100%;
}
#component-area hr {
	margin-top: 0px;
	margin-bottom: 0px;
}
/*START: SEARCH AREA*/
#top-search-area {
}
#top-search-show-hide-area {
	display: inline-flex;	
}
#top-search-switch-icon {
	display: inline-flex;
	float: right;
}
#top-search-area form fieldset {
	border-radius: 6px;
	margin-bottom: 0px;
	padding-bottom: 5px;
}
#top-search-area form fieldset label {
	margin-right: 10px;
}
#top-search-area form fieldset input[type="text"], select {
	border-radius: 6px;
	margin-right: 20px;
	border-color: darkgray;
	margin-top: 5px;
	margin-bottom: 5px;
}
#top-search-area form fieldset select {
	width: 20%;
}
#top-search-filters {
	display: inline;
}
#top-search-filters input {
	border-radius: 6px;
	margin-right: 20px;
	border-color: #A9A9A9;
}
/*END: SEARCH AREA*/
/*START: INNER COMPONENTS*/
.artifact-definition {
    padding: 5px 15px 15px;
    float: left;
    margin: 10px;
    border-radius: 10px;
    background-color: #868686;
    width: 20%;
    height: 20%;
    overflow-y: auto;
}
#artifact-definitions {
    display: inline-block;
	width: 100%;
}
.category-circle {
	width: 20px;
	height: 20px;
	border-radius: 10px;
	float: left;
	margin-bottom: 3px;
	margin-left: 2px;
	text-align: center;
}
.category-label {
	float: right;
	text-decoration: none;
	color: white;
	border-radius: 10px;
	padding-left: 5px;
	padding-right: 5px;
	margin-left: 5px;
	margin-right: 5px;
}
.centered-forms {
	margin-left: 1%;
	margin-right: 2%;
	margin-top: 1%;
}
.centered-forms-width38 {
	width: 38%;
}
.centered-forms form { 
	border-radius: 10px;
	border-style: inset;
	background-color: #7A7557;
	padding: 5px;
	border-width: 2px;
	width: 100%;
}
.centered-forms form fieldset {
	border: none;
} 
.centered-forms form input[type="text"]{ 
	border-radius: 10px;
	border-style: inset;
	width: 350px;
	margin-bottom: 5px;
}
.centered-forms form input[type="submit"] { 
	border-radius: 10px;
	width: 150px;
	border-right: 10px;
	margin-left: 3%;
	margin-right: 3%;
	margin-top: 1%;
}
.centered-forms form input[type="file"] { 
	border-radius: 10px;
	width: 400px;
	border-right: 10px;
	margin-top: 10px;
	margin-bottom: 5px;
}
.centered-forms form label { 
	display: block;
	margin-top: 10px;
}
.centered-forms form select { 
	border-radius: 10px;
	border-style: inset;
	display: block;
	width: 350px;
	margin-bottom: 10px;
}
.centered-forms form p { 
	margin-top: 10px;
	font-size: 20px;
	font-style: italic;
	text-align: right;
}
.centered-forms legend {
	text-align: center;
	font-size: 20px;
	color: black;
}
.centered-forms output {
	text-align: center;
	font-size: 16px;
	color: #EADDDD;
}
.centered-forms ul {
	border-radius: 15%;
	background-color: #F5F5DC;
}
.free-selected-process {
	float: right;
}
#free-tasks-list {
	overflow-y: auto;
	height: 625px;
}
#free-tasks-list ul {
	list-style-type: none;
	margin-top: 0px;
}
#granted-transitions {
	width: 60%;
	margin-left: auto;
	margin-right: auto;
}
.hide-lateral-left-list {
	float: left;
}
#item-customized-component {
	overflow-y: scroll;
	height: 60%;
}
.lateral-left-list {
	width: 19.5%;
	display: inline-block;
	height: 100%;
	font-size: 90%;
	box-shadow: 2px 2px 2px 0px rgba(11, 10, 10, 0.8) inset;
}
.lateral-left-list ul {
	list-style-type: none;
	padding-left: 2px;
}
.lateral-left-list a {
	text-decoration: none;
	color: black;
}  
.lateral-left-list ul li {
	margin-bottom: 10px;
}
.lateral-left-list-icon {
	width: 32px;
	float: left;
	padding-left: 5px;
	padding-top: 5px;
}
.lateral-left-list-item-selected {
	background-color: beige;
	border-radius: 10px;
	padding-left: 10px;
}
.lateral-left-list-item-unselected {
}
.lateral-left-list-item-summary-data {
	display: inline-block;
	color: rgb(37, 46, 146);
}
.lateral-left-list-item-summary-data output {
	display: block;
	margin-left: auto;
	margin-right: auto;
}
.lateral-left-list-item-title-selected {
	font-size: 150%;
}
.lateral-left-list-item-title-unselected {
	font-size: 150%;
}
.lateral-right-component-additional-data {
	text-align: center;
}
.lateral-right-component-additional-data span {
	font-style: italic;
	margin-right: 5px;
	margin-left: 15px;
	color: #8A8A59;
}
.lateral-right-component-additional-data output {
	color: darkblue;
}
.lateral-right-component {
	height: 100%;
	float: right;
	background-color: #BCBCBC;
}
.lateral-right-component-description {
	background-color: #E4E49E;
	padding-bottom: 15px;
	margin-left: 2px;
    margin-top: 2px;
    margin-right: 2px;
}
.lateral-right-component-main-data {
	font-size: 150%;
	text-align: center;
	padding-top: 1px;
}
.lateral-right-component-main-data a {
	float: right;
}
.lateral-right-component-width80 {
	width: 80.5%;
}
.lateral-right-component-width100 {
	width: 100%;
}
.lateral-right-component-secondary-data {
	text-align: center;
}
.lateral-right-component-secondary-data span {
	font-style: italic;
	margin-right: 5px;
	margin-left: 15px;
	color: #8A8A59;
}
.lateral-right-component-secondary-data output {
	color: darkblue;
}
.list-lateral-element {
	width: 90%;
}
.list-lateral-element-custom {
	float: right;
	width: 10%;
}
.list-lateral-item {
	display: flex;
	margin-bottom: 5px;
	margin-top: 5px;
}
.monitor-list-icon {
	float: left;
	display: inline;
}
.monitor-list-icon-2 {
	float: right;
	display: inline;
}
.monitor-list-icon-height75 {
	height: 75px;
}
.monitor-list-icon-height90 {
	height: 110px;
}
.monitor-list-item-data {}
.monitor-list-item-data span {
	font-style: italic;
}
.monitor-list-item-data output {
	color: #231D81;
	margin-left: 10px;
	float: right;
}
.monitor-list-item-summary {
	display: inline-block;
    margin: 20px;
    padding: 20px;
    background-color: white;
    border-radius: 10px;
}
.monitor-list-item-summary span {
	font-style: italic;
}
.new-process-options {
    width: 50%;
    float: left;
}
#new-process-options-form {
	display: inline-flex;
}
#new-process-list  ul {
	list-style-type: none;
	margin-top: 0px;
}
#orbeon-form-frame {
	height: 400px;
} 
#orbeon-form {
	height: 100%;
}
#orbeon-form iframe {
	width: 100%;
	height: 100%;
}
#process-definition {
	height: 100%;
	box-shadow: 2px 2px 2px 0px rgba(11, 10, 10, 0.8) inset;
}
#process-assigment-transitions {
	margin-left: 10px;
	margin-top: 10px;
	overflow-y: auto;
	height: 440px;
}
.process-transition-icon-collapse {
	float: right;
}
.process-transition-finished {
	padding: 15px;
	padding-top: 5px;
	float: left;
	margin: 10px 10px 10px 10px;
	border-radius: 25px;
	background-color: #8CBD80;
	width: 28%;
	height: 60%;
	overflow-y: auto;
	box-shadow: 0px 0px 3px 0px rgba(11, 10, 10, 0.8);
}
.process-transition-gateway {
	padding: 15px;
	padding-top: 5px;
	float: left;
	margin: 10px 10px 10px 10px;
	border-radius: 25px;
	background-color: #ADADAD;
	width: 28%;
	height: 60%;
	overflow-y: auto;
}
.process-transition-running {
	padding: 15px;
	padding-top: 5px;
	float: left;
	margin: 10px 10px 10px 10px;
	border-radius: 25px;
	width: 28%;
	height: 60%;
	overflow-y: auto;
	background-color: #80A0BD;
	box-shadow: 0px 0px 3px 0px rgba(11, 10, 10, 0.8);
}
.process-transition-collapsed {
	height: 1%;
}
.process-transition-expanded {
	height: 60%;
}
.transition-data span {
	margin-right: 20px;
	font-style: italic;
	color: #565656;
    display: inline-table;
}
.transition-data output  {
	color: rgb(50, 51, 122);
	float: right;
}
.unique-centered-table {
	margin-left: auto;
	margin-right: auto;
	border: 2px solid #000;
	border-radius: 10px;
	margin-top: 30px;

}
.unique-centered-table-width30 {
	width: 30%;
}
.unique-centered-table-width70 {
	width: 70%;
}
.unique-centered-table  table {
	width: 100%;
}
.unique-centered-table fieldset {
	border: 0px none;
	margin-left: auto;
	margin-right: auto;
	width: 150px;
	margin-top: 20px;
}
.unique-centered-table fieldset  input {
	border-radius: 10px
}
.unique-wide-list-icon {
	width: 2.5%;
	float: left;
	display: inline;
}
.unique-wide-list-icon-height75 {
	height: 75px;
}
.unique-wide-list-icon-height90 {
	height: 110px;
}
.unique-wide-list-item-data {}
.unique-wide-list-item-data span {
	font-style: italic;
}
.unique-wide-list-item-data output {
	color: #231D81;
	margin-left: 10px;
}
.unique-wide-list-item-summary {}
.unique-wide-list-item-summary span {
	font-style: italic;
}
/*END: INNER COMPONENTS*/
/* END: COMPONENT AREA */
/*   ESTILES IN TEST   */
.batch {
	border-radius: 5px;
	padding: 5px;
	background: beige;
	margin-right: 2px;
	margin-left: 2px;
	display: inline-block;
    text-decoration: none;
    color: black;
}
.batch-div-bottom {
	margin-top: -18px;
	margin-left: 25px;
}
.batch-div-lateral-top {
	margin-top: 10px;
	margin-bottom: -8px;
	margin-left: 5px;
}
.centered-unique-form {
	color: black;
	background-color: #BCBCBC;
	font-size: 18px;
	font-style: normal;
	border-radius: 5px;
	border: 1px solid #BCBCBC;
	border-width: 1px 1px 3px;
	margin-bottom: 10px;
	padding: 10px;
}
.centered-unique-form form {
	max-width: 350px;
	margin: 10px auto;
	padding: 10px 20px;
	background: #898a8a;
	border-radius: 8px;
}
.centered-unique-form fieldset {
	margin-bottom: 5px;
	border: none;
}
.centered-unique-form h1 {
	margin: 0 0 30px 0;
	text-align: center;
}
.centered-unique-form input[type="text"],
input[type="password"], input[type="date"],
input[type="datetime"], input[type="email"],
input[type="number"], input[type="search"],
input[type="tel"], input[type="time"],
input[type="url"], textarea, select {
	background: rgba(255,255,255,0.1);
	font-size: 16px;
	height: auto;
	margin: 0;
	outline: 0;
	width: 100%;
	background-color: white;
	color: black;
	box-shadow: 0 1px 0 rgba(0,0,0,0.03) inset;
	margin-bottom: 10px;
}
.centered-unique-form  input[type="radio"], input[type="checkbox"] {
	margin: 0 4px 8px 0;
}
.centered-unique-form select {
	padding: 6px;
	border-radius: 2px;
}
.centered-unique-form label {
	display: block;
	margin-bottom: 8px;
}
.centered-unique-form label.light {
	font-weight: 300;
	display: inline;
}
/* BASIC BLOCK STYLES */
.display-block {
	display: block;
}
.display-inline-block {
	display: inline-block;
}
.float-left {
	float: left;
}
.height180 {
	height: 180px;
}
.height250 {
	height: 250px;
}
.height300 {
	height: 300px;
}
.margin-right-20per {
	margin-right: 20%;
}
.margin-top-15px {
	margin-top: 15px;
}
.underline {
	text-decoration: underline;
}
/* RIGHT LATERAL TABLE STYLES */
.default-gray-table table {
	color:black;
	font-size:18px;
	background:#898a8a;
	margin:20px;
	border:#ccc 1px solid;

	-moz-border-radius:3px;
	-webkit-border-radius:3px;
	border-radius:3px;

	-moz-box-shadow: 0 1px 2px #d1d1d1;
	-webkit-box-shadow: 0 1px 2px #d1d1d1;
	border-radius: 10px;
	padding-bottom: 2px;
	padding-left: 2px;
	padding-right: 2px;
}
.default-gray-table table a:link {
	color: #666;
	font-weight: bold;
	text-decoration:none;
}
.default-gray-table table a:visited {
	color: #999999;
	font-weight:bold;
	text-decoration:none;
}
.default-gray-table table a:active,
.default-gray-table table a:hover {
	color: black;
	text-decoration:underline;
}
.default-gray-table table th {
	padding:10px 15px 5px 15px;
	background-color: #898a8a;
}
.default-gray-table table th:first-child {
	text-align: left;
	padding-left:20px;
}
.default-gray-table table tr:first-child th:first-child {
	-moz-border-radius-topleft:5px;
	-webkit-border-top-left-radius:5px;
	border-top-left-radius:5px;
}
.default-gray-table table tr:first-child th:last-child {
	-moz-border-radius-topright:3px;
	-webkit-border-top-right-radius:3px;
	border-top-right-radius:3px;
}
.default-gray-table table tr {
	text-align: center;
	padding-left:20px;
}
.default-gray-table table td:first-child {
	text-align: left;
	padding-left:20px;
	border-left: 0;
}
.default-gray-table table td {
	padding: 5px;
}
.default-gray-table table tr.even td {
	background: #f6f6f6;
	background: -webkit-gradient(linear, left top, left bottom, from(#f8f8f8), to(#f6f6f6));
	background: -moz-linear-gradient(top,  #f8f8f8,  #f6f6f6);
}
.default-gray-table table tr:last-child td {
	border-bottom:0;
}
.default-gray-table table tr:first-child td:first-child {
	-moz-border-radius-topleft:5px;
	-webkit-border-top-left-radius:5px;
	border-top-left-radius:5px;
}
.default-gray-table table tr:first-child td:last-child {
	-moz-border-radius-topright:5px;
	-webkit-border-top-right-radius:5px;
	border-top-right-radius:5px;
}
.default-gray-table table tr:last-child td:first-child {
	-moz-border-radius-bottomleft:5px;
	-webkit-border-bottom-left-radius:5px;
	border-bottom-left-radius:5px;
}
.default-gray-table table tr:last-child td:last-child {
	-moz-border-radius-bottomright:5px;
	-webkit-border-bottom-right-radius:5px;
	border-bottom-right-radius:5px;
}
.default-gray-table table tr:hover td {
	background: #f2f2f2;
	background: -webkit-gradient(linear, left top, left bottom, from(#f2f2f2), to(#f0f0f0));
	background: -moz-linear-gradient(top,  #f2f2f2,  #f0f0f0);	
}'! !

WASeasideBpmIntegration subclass: #WASeasideBpmIntegrationTestForm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWeb'!

!WASeasideBpmIntegrationTestForm class methodsFor: 'other' stamp: 'BrunoBB 12/21/2015 12:44'!
defaultModel

	^BpmSeasideTempObject new! !

!WASeasideBpmIntegrationTestForm methodsFor: 'other' stamp: 'BrunoBB 12/21/2015 12:44'!
renderContentOn: html

	taskInstance ifNil: [^self renderEditFormOn: html].

	taskInstance isDone ifFalse: [^self renderEditFormOn: html].

	^self renderViewFormOn: html.! !

!WASeasideBpmIntegrationTestForm methodsFor: 'other' stamp: 'BrunoBB 12/21/2015 12:44'!
renderEditFormOn: html

	html form with: [
		html fieldSet with: [
			self renderFormFieldsOn: html.
			html submitButton callback: [self answer]; with: ('Close' translateFor: self session user).
		].
	].! !

!WASeasideBpmIntegrationTestForm methodsFor: 'other' stamp: 'BrunoBB 12/21/2015 12:44'!
renderFormFieldsOn: html

	html legend with: ('New Category' translateFor: self session user).
	html label attributeAt: 'for' put: 'name'; with: ('Name' translateFor: self session user).
	html textInput attributeAt: 'id' put: 'name'; callback: [:value | model name: value]; value: model name.
	html label attributeAt: 'for' put: 'password'; with: ('Password' translateFor: self session user).
	html colorInput attributeAt: 'id' put: 'password'; callback: [:value | model password: value]; value: model password.! !

!WASeasideBpmIntegrationTestForm methodsFor: 'other' stamp: 'BrunoBB 12/21/2015 12:44'!
renderViewFormOn: html

	html form with: [
		html fieldSet disabled: true; with: [
			self renderFormFieldsOn: html.
		].
		html fieldSet with: [html submitButton callback: [self answer]; with: ('Close' translateFor: self session user).].
	].! !

WASession subclass: #WABpmSession
	instanceVariableNames: 'user password rols'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWeb'!

!WABpmSession methodsFor: 'other' stamp: 'BrunoBB 02/24/2016 15:20'!
isLoggedIn

    ^user isNil not! !

!WABpmSession methodsFor: 'other' stamp: 'BrunoBB 02/24/2016 15:20'!
login: aString
    user := aString! !

!WABpmSession methodsFor: 'other' stamp: 'BrunoBB 02/24/2016 15:20'!
logout
    user := nil! !

!WABpmSession methodsFor: 'Accessing' stamp: 'BrunoBB 02/24/2016 15:20'!
password

   "Return the value of the instance variable 'password'."
   ^password! !

!WABpmSession methodsFor: 'Updating' stamp: 'BrunoBB 02/24/2016 15:20'!
password: newValue

   "Modify the value of the instance variable 'password'."
   password := newValue! !

!WABpmSession methodsFor: 'Accessing' stamp: 'BrunoBB 02/24/2016 15:20'!
rols

   "Return the value of the instance variable 'rols'."
   ^rols! !

!WABpmSession methodsFor: 'Updating' stamp: 'BrunoBB 02/24/2016 15:20'!
rols: newValue

   "Modify the value of the instance variable 'rols'."
   rols := newValue! !

!WABpmSession methodsFor: 'other' stamp: 'BrunoBB 02/24/2016 15:20'!
user
    ^ user! !

!WABpmSession methodsFor: 'Updating' stamp: 'BrunoBB 02/24/2016 15:20'!
user: newValue

   "Modify the value of the instance variable 'user'."
   user := newValue! !

SEWAFWebObjectComposite subclass: #FormProcessChangePasswordComposite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWeb'!

!FormProcessChangePasswordComposite methodsFor: 'other' stamp: 'BrunoBB 01/29/2016 16:22'!
changePassword

	(self session user password = (searchValues at: 'current-pwd')) ifFalse: [^self inform: 'Invalid Current Password'].

	((searchValues at: 'repeat-new-pwd') = (searchValues at: 'new-pwd')) ifFalse: [^self inform: 'New Password and Repeat New Password must be equal.'].

	self session user password: (searchValues at: 'new-pwd').! !

!FormProcessChangePasswordComposite methodsFor: 'other' stamp: 'BrunoBB 03/02/2016 12:53'!
renderContentOn: html

	html div id: 'change-password'; class: 'centered-unique-form';
		with: [html form with: [
					html fieldSet with:[
						html legend with: [html strong: ('Change Password' translateFor: self session user)].
						html label attributeAt: 'for' put: 'currentPassword'; with: ('Current Password' translateFor: self session user).
						html textInput attributeAt: 'id' put: 'currentPassword'; callback: [:value | searchValues at: 'current-pwd' put: value].
						html label attributeAt: 'for' put: 'newPassword'; with: ('New Password' translateFor: self session user).
						html textInput attributeAt: 'id' put: 'newPassword'; callback: [:value | searchValues at: 'new-pwd' put: value].
						html label attributeAt: 'for' put: 'newPassword2'; with: ('Repeat New Password' translateFor: self session user).
						html textInput attributeAt: 'id' put: 'newPassword2'; callback: [:value | searchValues at: 'repeat-new-pwd' put: value].
						html submitButton callback: [self changePassword]; with: ('Confirm' translateFor: self session user).
					].
				].
		].! !

SEWAFWebObjectComposite subclass: #FormProcessUserPreferenceComposite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWeb'!

!FormProcessUserPreferenceComposite methodsFor: 'other' stamp: 'BrunoBB 03/02/2016 12:54'!
renderContentOn: html

	html div id: 'user-preferences'; class: 'centered-unique-form';
		with: [html form with: [
					html fieldSet with:[
						html legend with: [html strong: ('Preferences' translateFor: self session user)].
						html output with: ('(true- embedded, false - in other page)' translateFor: self session user).
						html break.
						html checkbox 
							attributeAt: 'id' put: 'viewForm';
							callback: [:value | self session user orbeonWebIsLinked: value]; value: self session user orbeonWebIsLinked.
						html label attributeAt: 'for' put: 'viewForm'; with: ('View Form Embedded' translateFor: self session user).
						html break.
						html checkbox 
							attributeAt: 'id' put: 'transitionsDisplayModel';
							callback: [:value | self session user setTransitionsDisplayMode: value]; value: self session user transitionDisplayModeIsExpanded.
						html label attributeAt: 'for' put: 'transitionsDisplayModel'; with: ('Expanded Transitions Display Mode' translateFor: self session user).
						html submitButton callback: [self savePreferences]; with: ('Save Preferences' translateFor: self session user).
					].
				].
		].! !

!FormProcessUserPreferenceComposite methodsFor: 'other' stamp: 'BrunoBB 01/29/2016 16:22'!
savePreferences! !

SEWAFWebObjectComposite subclass: #UserLanguageComposite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWeb'!

!UserLanguageComposite methodsFor: 'other' stamp: 'BrunoBB 01/29/2016 16:22'!
currentDictionaryName

	^searchValues at: 'selected-language' ifAbsent: ['']! !

!UserLanguageComposite methodsFor: 'other' stamp: 'BrunoBB 03/02/2016 12:54'!
renderContentOn: html

	html div id: 'internationalization'; class: 'centered-unique-form'; with: [
		html form with: [ 
			html fieldSet with: [
			html legend with: [html strong: ('Languages' translateFor: self session user)].
					html label attributeAt: 'for' put: 'language'; with: ('Select Language' translateFor: self session user).
					html select 
						attributeAt: 'id' put: 'language';
						class: '';
						list: (#(''), self getInternationalization currentDictionaries);
						callback: [:value | searchValues at: 'selected-language' put: value];
						selected: self session user currentLanguage.
					html submitButton 
						callback: [self setLanguage]; 
						with: ('Set Language' translateFor: self session user).
				].
		].
	].! !

!UserLanguageComposite methodsFor: 'other' stamp: 'BrunoBB 01/29/2016 16:22'!
setLanguage

	self session user setLanguage: self currentDictionaryName! !

SEWAFWebObjectComposite subclass: #WABpmUnassignedTaskBrowser
	instanceVariableNames: 'unassignedTask'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWeb'!

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 12:44'!
hasSearchValueAt: aString

	^(self searchValueAt: aString)
		ifNotNil: [:each | each notEmpty]
		ifNil: [false]! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 09:26'!
initialize

	super initialize.

	unassignedTask := OrderedCollection new.! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 09:57'!
onApplicationChanged: appName

	searchValues at: 'application' put: appName! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 09:32'!
onRoleChanged: roleName

	searchValues at: 'role' put: roleName.! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 12:33'!
renderApplicationsComboOn: html

	html label attributeAt: 'for' put: 'applications'; with: ('Applications' translateFor: self session user).
	html select "Process Definition List"
		attributeAt: 'id' put: 'applications'; 
		list: (#(''), (self session user getApplications collect: [:each | each applicationName])) asSortedCollection;
		callback: [:appName | self onApplicationChanged: appName];
		onChange: 'submit()';
		selected: (searchValues at: 'application' ifAbsent: ['']).! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 01/17/2016 15:43'!
renderBpmTaskAssignment: aBpmTaskAssignment on: html 

	"self renderTakeTaskIconOn: html for: eachProcess."

		html div class: 'monitor-list-item-summary'; with: [
			html div class: 'monitor-list-item-data'; with: [
				html strong with: [html span: ('Top Application:' translateFor: self session user)].
				html output: aBpmTaskAssignment applicationName.].
			html div class: 'monitor-list-item-data'; with: [
				html strong with: [html span: ('Process Id:' translateFor: self session user)].
				html output: aBpmTaskAssignment processId.].
			html div class: 'monitor-list-item-data'; with: [
				html strong with: [html span: ('Process Name:' translateFor: self session user)].
				html output: aBpmTaskAssignment processName.].
			html div class: 'monitor-list-item-data'; with: [
				html strong with: [html span: ('Creation Date:' translateFor: self session user)].
				html output: aBpmTaskAssignment creationDate.].
			html div class: 'monitor-list-item-data'; with: [
				html strong with: [html span: ('Task Name:' translateFor: self session user)].
				html output: aBpmTaskAssignment taskName.].
			html div class: 'monitor-list-item-data'; with: [
				html strong with: [html span: ('Role:' translateFor: self session user)].
				html output: aBpmTaskAssignment getRoleName.].
			html div class: 'monitor-list-item-data'; with: [
				html strong with: [html span: ('Parent Process:' translateFor: self session user)].
				html output: aBpmTaskAssignment printParentName.].
			html div class: 'monitor-list-item-data'; with: [
				html strong with: [html span: ('And Context:' translateFor: self session user)].
				html output: aBpmTaskAssignment printAndContext.].
			html div class: 'monitor-list-item-data'; with: [
				html strong with: [html span: ('Or Context:' translateFor: self session user)].
				html output: aBpmTaskAssignment printOrContext.].
			self renderTakeTaskIconOn: html for: aBpmTaskAssignment.
		].! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 09:27'!
renderContentOn: html

	html horizontalRule.

	html div id: 'top-search-area'; with: [self renderSearchAreaOn: html.].

	html div id: 'free-tasks-list'; with: [self renderUnassignedTasksOn: html.].! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 10:01'!
renderRolesComboOn: html
	| roles appName |

	appName := searchValues at: 'application' ifAbsent: [''].
	roles := appName isEmpty
		ifFalse: [self session user roles select: [:each | each getApplicationName = appName] thenCollect: [:each | each name]]
		ifTrue: [#()].

	html label attributeAt: 'for' put: 'roles'; with: ('Roles' translateFor: self session user).
	html select "Process Definition List"
		attributeAt: 'id' put: 'roles'; 
		list: (#(''), roles) asSortedCollection;
		callback: [:roleName | self onRoleChanged: roleName];
		selected: (searchValues at: 'role' ifAbsent: ['']).! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 09:32'!
renderSearchAreaOn: html

	html form with: [ 
		html fieldSet with: [
			html div id: 'top-search-filters'; with: [
				self renderApplicationsComboOn: html.
				self renderRolesComboOn: html.
				self renderSearchSubmitButtonOn: html.
			].

			"html div id: 'top-search-filters'; with: [
				self renderFilterValuesAndButtonOn: html]."
		].
]! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 11:33'!
renderSearchSubmitButtonOn: html

	html submitButton 
		class: 'search-section-float search-section-width-100';
		callback: [self searchTasksAssignments]; 
		with: ('Search' translateFor: self session user).! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 03/06/2016 12:16'!
renderTakeTaskIconOn: html for: aBpmTaskAssignment

	html div class: 'monitor-list-icon'; with: [
		html anchor callback: [self takeTask: aBpmTaskAssignment];
			with: [html image url: (SEWAFIconLibrary / #tasks32Png); 
						altText: 'Take Task';
						title: 'Take Task'].].

	html div class: 'monitor-list-icon-2'; with: [
		html anchor callback: [self takeTaskAndGo: aBpmTaskAssignment];
			with: [html image url: (SEWAFIconLibrary / #applicationarrowright32Png); 
						altText: 'Take Task and Go';
						title: 'Take Task and Go'].].! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 11:32'!
renderUnassignedTasksOn: html

	unassignedTask do: [:each | self renderBpmTaskAssignment: each on: html].! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 12:23'!
searchAll

	unassignedTask := self session user getAllAvailableTaskAssignments! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 12:45'!
searchTasksAssignments
	| matrix |

	((self hasSearchValueAt: 'application') and: [(self hasSearchValueAt: 'role')]) 
	ifTrue: [matrix := BpmRunningTasksMatrix getMatrixForApplicationNamed: (searchValues at: 'application').
				unassignedTask := matrix getAvailableTasksFor: (searchValues at: 'role').]
	ifFalse: [self searchAll].! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 03/06/2016 12:21'!
takeTask: aBpmTaskAssignment
	"The current user take this task and the page is refreshed"

	self session user take: aBpmTaskAssignment.

	self searchAll! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 03/06/2016 14:07'!
takeTaskAndGo: aBpmTaskAssignment
	"The current user take this task and then go to the process browser"
	| messages subMenu |

	self session user take: aBpmTaskAssignment.
	self answer.

	messages := OrderedCollection new.

	subMenu := mainPanel selectSubTabNamed: 'Current Processes' inMenu: 'My Processes' ifNone: [^nil].

	messages 
		add: (MessageSend receiver: mainPanel selector: #showCurrentProcess: argument: (OrderedCollection with: aBpmTaskAssignment));
		add: (MessageSend receiver: mainPanel selector: #selectedLateralItem: argument: aBpmTaskAssignment).

	subMenu addMessagesToSend: messages.! !

!WABpmUnassignedTaskBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 12/08/2015 09:25'!
unassignedTask
	^unassignedTask! !

!WABpmUnassignedTaskBrowser methodsFor: 'Updating' stamp: 'BrunoBB 12/08/2015 09:25'!
unassignedTask: newValue
	unassignedTask := newValue! !

SEWAFWebObjectComposite subclass: #WAFreeTransitionBagBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWeb'!

!WAFreeTransitionBagBrowser methodsFor: 'other' stamp: 'BrunoBB 01/29/2016 16:25'!
checkIfProcessStillAvailable: anOrbeonFormProcess
	"Check if another user has taken the process already"

	^anOrbeonFormProcess checkIfStillAvailableFor: self session user! !

!WAFreeTransitionBagBrowser methodsFor: 'other' stamp: 'BrunoBB 02/07/2016 15:15'!
getFreeTransitions

	^BpmProcessDefinition getFreeTransitionsFor: self session user! !

!WAFreeTransitionBagBrowser methodsFor: 'other' stamp: 'BrunoBB 01/29/2016 16:25'!
getProcessWithFreeTransitions

	^self getFreeTransitions keys asArray! !

!WAFreeTransitionBagBrowser methodsFor: 'other' stamp: 'BrunoBB 01/29/2016 16:25'!
renderContentOn: html

	html horizontalRule.
	html div id: 'free-tasks-list'; with: [
		html unorderedList with:[
			self getProcessWithFreeTransitions do: [:eachProcess |
				html listItem with: [
					self renderFreeProcessOn: html for: eachProcess.
					html horizontalRule.].
				].
			].].! !

!WAFreeTransitionBagBrowser methodsFor: 'other' stamp: 'BrunoBB 01/29/2016 16:25'!
renderFreeProcessOn: html for: eachProcess

	self renderTakeTaskIconOn: html for: eachProcess.

	html div class: 'unique-wide-list-item-summary'; with: [
		html div class: 'unique-wide-list-item-data'; with: [
			html strong with: [html span: ('Process Id:' translateFor: self session user)].
			html output: eachProcess processId.].
		html div class: 'unique-wide-list-item-data'; with: [
			html strong with: [html span: ('Process Name:' translateFor: self session user)].
			html output: eachProcess name.].
		html div class: 'unique-wide-list-item-data'; with: [
			html strong with: [html span: ('Current Forms:' translateFor: self session user)].
			html output: eachProcess printRunningArtifacts.].
		html div class: 'unique-wide-list-item-data'; with: [
			html strong with: [html span: ('Roles:' translateFor: self session user)].
			html output: eachProcess printCurrentRols.].
		html div class: 'unique-wide-list-item-data'; with: [
			html strong with: [html span: ('Creator:' translateFor: self session user)].
			html output: eachProcess creatorName.].
		html div class: 'unique-wide-list-item-data'; with: [
			html strong with: [html span: ('Creation Time:' translateFor: self session user)].
			html output: eachProcess createdTime.].].! !

!WAFreeTransitionBagBrowser methodsFor: 'other' stamp: 'BrunoBB 01/29/2016 16:25'!
renderTakeTaskIconOn: html for: anOrbeonFormProcess

	html div class: 'unique-wide-list-icon unique-wide-list-icon-height90'; with: [
		html anchor callback: [self takeTask: anOrbeonFormProcess];
			with: [html image url: (SEWAFIconLibrary / #tasks32Png); 
						altText: 'Take Task';
						title: 'Take Task'].].! !

!WAFreeTransitionBagBrowser methodsFor: 'other' stamp: 'BrunoBB 02/07/2016 15:18'!
takeTask: anOrbeonFormProcess

	(self checkIfProcessStillAvailable: anOrbeonFormProcess) 
	ifFalse: [^self inform: 'Process [', 
						anOrbeonFormProcess processId printString, '] [', 
						anOrbeonFormProcess name, '] [',
						anOrbeonFormProcess printRunningArtifacts,'] - Has been already Taken by other user !!!!!!']. 

	^BpmTaskAssignment associateWithProcess: anOrbeonFormProcess for: self session user! !

SEWAFWebObjectComposite subclass: #WAOrbeonGrantedTransitionManager
	instanceVariableNames: 'batchedList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWeb'!

!WAOrbeonGrantedTransitionManager methodsFor: 'Accessing' stamp: 'BrunoBB 03/08/2016 14:33'!
batchedList
	^batchedList! !

!WAOrbeonGrantedTransitionManager methodsFor: 'Updating' stamp: 'BrunoBB 03/08/2016 14:33'!
batchedList: newValue
	batchedList := newValue! !

!WAOrbeonGrantedTransitionManager methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 15:05'!
initialize

	super initialize.

	batchedList := SewafBatchedList parentComponent: self items: self session user getGrantedTasks.

	batchedList batchSize: 10;
		isBottomBatch: true;
		navigationCssClass: 'batch-div-bottom'.! !

!WAOrbeonGrantedTransitionManager methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 14:34'!
renderContentOn: html

	html div id: 'granted-transitions';class: 'default-gray-table';
		with:[html render: (batchedList table: self sewafTableForFormTransitionsDefinitions).].! !

!WAOrbeonGrantedTransitionManager methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 14:34'!
sewafTableForFormTransitionsDefinitions

	^(SewafSelectTableReport summary: 'Artifacts')
		"rows: self session user getGrantedTasks; "
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #applicationName title: 'Application');
						add: (SewafReportColumn selector: #processDefinitionName title: 'Process');
						"add: (SewafReportColumn selector: #startFormName title: 'Required Form');"
						add: (SewafReportColumn selector: #name title: 'Form to Fill');
						add: (SewafReportColumn selector: #printRoleNames title: 'Roles');
						yourself);
		rowColors: #(white white);
		rowPeriod: 1;
		yourself! !

SEWAFWebObjectComposite subclass: #WAOrbeonProcessCategoryManager
	instanceVariableNames: 'selectedCategory batchedList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWeb'!

!WAOrbeonProcessCategoryManager methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 11:42'!
categoryColorColumn

	^(SewafReportColumn 
			renderBlock: [:each :html | 
				html colorInput 
					attributeAt: 'title' put: ('Color' translateFor: self session user);
					value: each color.] 
			title: 'Color') sortBlock: nil; 
			yourself! !

!WAOrbeonProcessCategoryManager methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 14:17'!
createNewCategory

	model addToCacheIn: self session user username.

	batchedList items add: model.

	model := BpmProcessInstanceCategory new.! !

!WAOrbeonProcessCategoryManager methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 11:42'!
getAllUserCategories

	^BpmProcessInstanceCategory getCategoriesFor: self session user! !

!WAOrbeonProcessCategoryManager methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 15:07'!
initialize

	super initialize.

	model := BpmProcessInstanceCategory new.
	batchedList := SewafBatchedList parentComponent: self items: self getAllUserCategories.

	batchedList batchSize: 10;
		isBottomBatch: true;
		navigationCssClass: 'batch-div-bottom'.! !

!WAOrbeonProcessCategoryManager methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 11:42'!
modifyCategory

	selectedCategory removeFromCacheFrom: self session user username.

	selectedCategory name: (self componentValueAt: 'name').
	selectedCategory color: (self componentValueAt: 'color').

	selectedCategory addToCacheIn: self session user username.! !

!WAOrbeonProcessCategoryManager methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 16:26'!
removeCategory

	selectedCategory removeFromCacheFrom: self session user username.

	batchedList items remove: selectedCategory ifAbsent: [].

	selectedCategory := nil.

	model := BpmProcessInstanceCategory new.! !

!WAOrbeonProcessCategoryManager methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 11:42'!
renderCategoryFormOn: html

	html form with: [
		html fieldSet with: [
			selectedCategory 
				ifNil: [self renderNewCategoryFormOn: html]
				ifNotNil: [self renderSelectedCategoryFormOn: html]
		].
	]! !

!WAOrbeonProcessCategoryManager methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 11:46'!
renderContentOn: html

	html div id: 'top-search-area'; class: 'centered-unique-form float-left'; with: [self renderCategoryFormOn: html].

"	html div class: 'default-gray-table float-left';
		with:[html render: self sewafTableForUserCategories.]."

	html div class: 'default-gray-table float-left';
		with:[html render: (batchedList table: self sewafTableForUserCategories).].! !

!WAOrbeonProcessCategoryManager methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 11:42'!
renderNewCategoryFormOn: html

	html legend with: [html strong: ('New Category' translateFor: self session user)].
	html label attributeAt: 'for' put: 'categotyName'; with: ('Category Name' translateFor: self session user).
	html textInput attributeAt: 'id' put: 'categotyName'; callback: [:value | model name: value].
	html label attributeAt: 'for' put: 'color'; with: ('Color' translateFor: self session user).
	html colorInput attributeAt: 'id' put: 'color'; callback: [:value | model color: value].
	html submitButton 
		class: 'display-block margin-top-15px';
		callback: [self createNewCategory]; 
		with: ('Create Category' translateFor: self session user).! !

!WAOrbeonProcessCategoryManager methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 11:42'!
renderSelectedCategoryFormOn: html

	html legend with: [html strong: ('Selected Category' translateFor: self session user)].
	html label attributeAt: 'for' put: 'categotyName'; with: ('Category Name' translateFor: self session user).
	html textInput 
		attributeAt: 'id' put: 'categotyName';
		value: selectedCategory name;
		callback: [:value | self addValue: value named: 'name'].
	html label attributeAt: 'for' put: 'color'; with: ('Color' translateFor: self session user).
	html colorInput 
		attributeAt: 'id' put: 'color';
		value: selectedCategory color; 
		callback: [:value | self addValue: value named: 'color'].
	html submitButton 
		class: 'display-block margin-top-15px';
		callback: [self modifyCategory]; 
		with: ('Modify Category' translateFor: self session user).
	html submitButton 
		class: 'display-block margin-top-15px';
		callback: [self removeCategory]; 
		with: ('Remove Category' translateFor: self session user)! !

!WAOrbeonProcessCategoryManager methodsFor: 'Accessing' stamp: 'BrunoBB 03/08/2016 11:42'!
selectedCategory

   "Return the value of the instance variable 'selectedCategory'."
   ^selectedCategory! !

!WAOrbeonProcessCategoryManager methodsFor: 'Updating' stamp: 'BrunoBB 03/08/2016 11:42'!
selectedCategory: newValue

   "Modify the value of the instance variable 'selectedCategory'."
   selectedCategory := newValue! !

!WAOrbeonProcessCategoryManager methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 11:43'!
sewafTableForUserCategories

	^(SewafSelectTableReport summary: 'User Process Categories')
		"rows: self getAllUserCategories; "
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #name title: 'Category Name' onClick: 
						[:each | (selectedCategory == each) 
									ifTrue: [model := BpmProcessInstanceCategory new. selectedCategory := nil] 
									ifFalse: [model := selectedCategory := each]]);
						add: self categoryColorColumn;
						yourself);
		selectedObject: selectedCategory;
		rowColors: #(white white);
		rowPeriod: 1;
		yourself! !
